// 获取视图对象
var articledetailView = caac.guiframe.getView("articledetail");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    articledetailView.initParams = args;

    // 初始化控件
    articledetailView.initWidgets();
    // 初始化数据
    articledetailView.initData();
    // 初始化事件
    articledetailView.initEvents();
}

/**
 * 初始化控件
 */
articledetailView.initWidgets = function () {

    articledetailView.viewModel = kendo.observable({
        title: null,
        issueDateName: null,
        subjectTitle: null
    });

    kendo.bind($(".fj-news-dialog"), articledetailView.viewModel);
};

/**
 * 初始化数据
 */
articledetailView.initData = function () {

    caac.guiframe.showScreenPanel();

    // 发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "articledetail/initdata.act", articledetailView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                articledetailView.viewModel.set("title", data.bean.title);
                articledetailView.viewModel.set("issueDateName", data.bean.issueDateName);
                articledetailView.viewModel.set("subjectTitle", articledetailView.initParams.subjectTitle);

                var reg = new RegExp("../imagebrowser", "g")
                var newContent = data.bean.content.replace(reg, caac.constants.httpHead.URLHEAD + "articledetail");
                $(".fj-news-dialog .fj-news-content").append(newContent);

                // 如果有附件
                if (caac.util.isNotEmpty(data.fileList)) {

                    //如果有附件，显示附件按钮
                    document.getElementById("dv_news_attachments").className = "fj-news-attachments";


                    // 取得列表视图模板
                    var template = kendo.template($(".fj-news-dialog #dv_attachments_item").html());

                    $.each(data.fileList, function (n, value) {

                        // 循环附件
                        $(".fj-news-dialog #dv-attachments-list").append(template(value));
                    });

                    // 附件按钮绑定点击事件
                    $(".fj-news-dialog #dv_news_attachments").bind("click", function () {

                        var change = document.getElementById("dv-attachments-list");

                        if (change.className.indexOf("fj-hidden") == -1) {

                            change.className = "fj-attachments-list fj-hidden";
                        } else {

                            change.className = "fj-attachments-list";
                        }
                    });
                }

                // 设置历史记录的标题
                var historyTitle = data.bean.title;

                if (articledetailView.initParams.newsType == 1) {
                    // 设置历史记录
                    var articleHistory = JSON.parse(localStorage.getItem("articleHistory"));

                    if (articleHistory == null) {

                        var articleHistoryArray = new Array();

                        articleHistoryArray.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("articleHistory", JSON.stringify(articleHistoryArray));
                    } else if (articleHistory.length < 10) {

                        for (let i = 0; i < articleHistory.length; i++) {
                            if (JSON.stringify(articleHistory[i]) == JSON.stringify({
                                title: historyTitle,
                                articleNo: data.bean.articleNo,
                                subjectTitle: articledetailView.initParams.subjectTitle
                            })) {
                                articleHistory.splice(i, 1);
                                break;
                            }
                        }

                        articleHistory.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("articleHistory", JSON.stringify(articleHistory));
                    } else {

                        var bl = true;

                        for (let i = 0; i < articleHistory.length; i++) {
                            if (JSON.stringify(articleHistory[i]) == JSON.stringify({
                                title: historyTitle,
                                articleNo: data.bean.articleNo,
                                subjectTitle: articledetailView.initParams.subjectTitle
                            })) {
                                articleHistory.splice(i, 1);
                                bl = false;
                                break;
                            }
                        }

                        if (bl) {
                            articleHistory.shift();
                        }

                        articleHistory.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("articleHistory", JSON.stringify(articleHistory));
                    }
                } else {
                    // 设置历史记录
                    var informationHistory = JSON.parse(localStorage.getItem("informationHistory"));

                    if (informationHistory == null) {

                        var informationHistoryArray = new Array();

                        informationHistoryArray.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("informationHistory", JSON.stringify(informationHistoryArray));
                    } else if (informationHistory.length < 10) {

                        for (let i = 0; i < informationHistory.length; i++) {
                            if (JSON.stringify(informationHistory[i]) == JSON.stringify({
                                title: historyTitle,
                                articleNo: data.bean.articleNo,
                                subjectTitle: articledetailView.initParams.subjectTitle
                            })) {
                                informationHistory.splice(i, 1);
                                break;
                            }
                        }

                        informationHistory.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("informationHistory", JSON.stringify(informationHistory));
                    } else {

                        var bl = true;

                        for (let i = 0; i < informationHistory.length; i++) {
                            if (JSON.stringify(informationHistory[i]) == JSON.stringify({
                                title: historyTitle,
                                articleNo: data.bean.articleNo,
                                subjectTitle: articledetailView.initParams.subjectTitle
                            })) {
                                informationHistory.splice(i, 1);
                                bl = false;
                                break;
                            }
                        }

                        if (bl) {
                            informationHistory.shift();
                        }

                        informationHistory.push({
                            title: historyTitle,
                            articleNo: data.bean.articleNo,
                            subjectTitle: articledetailView.initParams.subjectTitle
                        });

                        localStorage.setItem("informationHistory", JSON.stringify(informationHistory));
                    }
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 初始化事件
 */
articledetailView.initEvents = function () {

    // 返回按钮
    $(".fj-news-dialog #dv_back_list").bind("click", function () {

        // 如果是从list页面打开
        if (articledetailView.initParams.subjectNo != null) {

            articledetailView.articleList = {};
            articledetailView.articleList.subjectNo = articledetailView.initParams.subjectNo;
            articledetailView.articleList.subjectTitle = articledetailView.initParams.subjectTitle;
            articledetailView.articleList.newsType = articledetailView.initParams.newsType;

            caac.guiframe.switchView("articlelist", articledetailView.articleList, null, ".fj-content-container");
        } else {

            // 从历史记录打开
            articledetailView.informationList = {};
            articledetailView.informationList.newsType = articledetailView.initParams.newsType;

            caac.guiframe.switchView("informationlist", articledetailView.informationList, null, ".fj-content-container");
        }

    });
};

/**
 * 下载附件
 */
articledetailView.onViewAttachmentClicked = function onViewAttachmentClicked(checkSum, fileName) {

    cordova.InAppBrowser.open(encodeURI(encodeURI(caac.constants.httpHead.URLHEAD + "articledetail/download.act?checkSum=" + checkSum + "&fileName=" + fileName)), '_system');
};