// 获取页面对象
var articleListView = caac.guiframe.getView("otherfaultlist");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    articleListView.initParams = args;

    // 初始化控件
    articleListView.initWidgets();
    // 初始化数据
    articleListView.initData();
    // 初始化事件
    articleListView.initEvents();
}

/**
 * 初始化控件
 */
articleListView.initWidgets = function () {

    articleListView.viewModel = kendo.observable({
        title: null
    });

    kendo.bind($(".fj-articlelist-panel"), articleListView.viewModel);
};

/**
 * 初始化数据
 */
articleListView.initData = function () {

    caac.guiframe.showScreenPanel();

    articleListView.initParams.pageNum = 1;

    articleListView.viewModel.set("title", articleListView.initParams.subjectTitle);

    // 发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "articlelist/initdata.act", articleListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {
                if (caac.util.isNotEmpty(data.list)) {

                    // 取得列表视图模板
                    var gridTemplate = kendo.template($(".fj-articlelist-panel #articlelist_grid_content").html());
                    // 设置列表视图内容
                    $(".fj-articlelist-panel .fj-article-container").html(gridTemplate(data.list));

                } else {

                    $(".fj-articlelist-panel .fj-article-container").html("");
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 初始化事件
 */
articleListView.initEvents = function () {

    // 返回按钮
    $(".fj-articlelist-panel #dv_back_home").bind("click", function () {

        articleListView.news = {};
        articleListView.news.newsType = articleListView.initParams.newsType;

        caac.guiframe.switchView("informationlist", articleListView.news, null, ".fj-content-container");
    })
};

/**
 * 跳转到明细页面
 */
articleListView.onClickDetail = function (articleNo) {

    // 所需数据
    articleListView.articleDetail = {};
    articleListView.articleDetail.articleNo = articleNo;
    articleListView.articleDetail.subjectNo = articleListView.initParams.subjectNo;
    articleListView.articleDetail.subjectTitle = articleListView.initParams.subjectTitle;
    articleListView.articleDetail.newsType = articleListView.initParams.newsType;

    // 页面跳转
    caac.guiframe.switchView("articledetail", articleListView.articleDetail, null, ".fj-content-container");
};

/**
 * 点击更多
 */
articleListView.onShowMoreClicked = function () {

    caac.guiframe.showScreenPanel();

    articleListView.initParams.pageNum = parseInt(articleListView.initParams.pageNum) + 1;

    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "articlelist/initdata.act", articleListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {

                    var gridTemplate = kendo.template($(".fj-articlelist-panel #articlelist_row_content").html());
                    // 循环处理需要增加的数据
                    for (var i = 0, len = data.list.length; i < len; i++) {
                        // 设置列表视图内容
                        $(".fj-articlelist-panel .fj-article-container .fj-article-item:nth-last-child(2)").after(gridTemplate(data.list[i]));
                    }
                    if (data.list.length < 10) {
                        // 设置显示更多按钮不可见
                        $(".fj-articlelist-panel .fj-show-more").addClass("fj-hidden");
                    }
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};
