// 获取页面对象
var commonView = caac.guiframe.getView("common");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // commonType:1、人员，2、单位+人员
    commonView.initParams = args;
    // 初始化控件
    commonView.initWidgets();
    // 初始化数据
    commonView.initData();
    // 初始化事件
    commonView.initEvents();
}

/**
 * 初始化控件
 */
commonView.initWidgets = function () {

    commonView.viewModel = kendo.observable({
        searchContent: null,
        count: 0
    });

    kendo.bind($(".fj-common-container"), commonView.viewModel);

    // 如果只是选择人员，隐藏单位选项
    if (commonView.initParams.commonType == 1) {

        $("#dv_category_personnel").removeClass("fj-hidden");

    } else if(commonView.initParams.commonType == 2) {

        $("#dv_category_unit").removeClass("fj-hidden");
        $("#dv_category_personnel").removeClass("fj-hidden");
    }

    // 显示历史记录
    var searchPersonnelHistory = JSON.parse(localStorage.getItem("searchPersonnelHistory"));

    if (caac.util.isNotEmpty(searchPersonnelHistory)) {

        // 取得视图模版
        var gridTemplate = kendo.template($(".fj-common-container #tmplt_personnel_history").html());
        // 设置列表视图内容
        $(".fj-common-container #dv_recent_result").html(gridTemplate(searchPersonnelHistory));
    } else {

        // 取得视图模版
        var gridTemplate = kendo.template($(".fj-common-container #tmplt_none_history").html());
        // 设置列表视图内容
        $(".fj-common-container #dv_recent_result").html(gridTemplate);
    }
};

/**
 * 初始化数据
 */
commonView.initData = function () {

    // 初始化选择的查询类型
    commonView.initParams.selectType = 1;

    // 初始化已选中的单位、人员
    var selectBean = commonView.initParams.bean;
    if (caac.util.isNotEmpty(selectBean.addresseeStrArr)) {

        var unitTemplate = kendo.template($(".fj-common-container #tmplt_selected_unit").html());
        var personnelTemplate = kendo.template($(".fj-common-container #tmplt_selected_personnel").html());

        $(".fj-common-container .fj-selected-list").html("");

        var num = 0;

        $.each(selectBean.addresseeStrArr, function (n, value) {

            num++;

            if (value.no.substr(0, 1) != "U") {

                // 将数据放入模板并显示在对应位置
                $(".fj-common-container .fj-selected-list").append(unitTemplate(value));
            } else {

                // 将数据放入模板并显示在对应位置
                $(".fj-common-container .fj-selected-list").append(personnelTemplate(value));
            }
        });

        commonView.viewModel.set("count", num);
    }
};

/**
 * 初始化事件
 */
commonView.initEvents = function () {

    // 绑定已选中数据隐藏弹出按钮
    $(".fj-common-container .fj-selected-summary > div:first-child").bind("click", function (event) {

        var selectedList = $(".fj-common-container .fj-selected-list");

        if (selectedList.hasClass("slideOutDown")) {

            selectedList.removeClass("fj-hidden").removeClass("slideOutDown").addClass("slideInUp");
        } else {

            selectedList.removeClass("slideInUp").addClass("slideOutDown");
        }
    });

    // 绑定搜索按钮
    $(".fj-common-container .fj-search-button").bind("click", function (event) {

        commonView.onSearch(event);
    });

    // 绑定“选好了”按钮
    $(".fj-common-container #dv_save").bind("click", function (event) {

        commonView.initParams.isCommon = 1;
        caac.guiframe.switchView(commonView.initParams.viewName, commonView.initParams, null, ".fj-content-container");
    });
};

/**
 * 页面检索方法
 */
commonView.onSearch = function (event) {

    var searchContent = commonView.viewModel.get("searchContent");

    if (caac.util.isNotBlank(searchContent)) {

        var args = {content: searchContent};

        if (commonView.initParams.selectType == 1) {

            // 人员查询
            caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "personnelselect/search.act", args, function (result) {
                caac.util.doReturnValue({
                    returnValue: result,
                    success: function (data) {

                        //如果查询结果有数据
                        if (caac.util.isNotEmpty(data.list)) {

                            // 取得视图模版
                            var gridTemplate = kendo.template($(".fj-common-container #tmplt_result_personnel").html());
                            // 设置列表视图内容
                            $(".fj-common-container #dv_recent_result").html(gridTemplate(data.list));
                        } else {

                            // 取得视图模版
                            var gridTemplate = kendo.template($(".fj-common-container #tmplt_result_none").html());
                            // 设置列表视图内容
                            $(".fj-common-container #dv_recent_result").html(gridTemplate);
                        }
                    },
                    error: function (data) {

                        caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                    }
                });
            });
        } else if (commonView.initParams.selectType == 2) {

            // 单位查询
            caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "unitselect/search.act", args, function (result) {
                caac.util.doReturnValue({
                    returnValue: result,
                    success: function (data) {

                        //如果查询结果有数据
                        if (caac.util.isNotEmpty(data.list)) {

                            // 取得视图模版
                            var gridTemplate = kendo.template($(".fj-common-container #tmplt_result_unit").html());
                            // 设置列表视图内容
                            $(".fj-common-container #dv_recent_result").html(gridTemplate(data.list));

                        } else {

                            // 取得视图模版
                            var gridTemplate = kendo.template($(".fj-common-container #tmplt_result_none").html());
                            // 设置列表视图内容
                            $(".fj-common-container #dv_recent_result").html(gridTemplate);
                        }
                    },
                    error: function (data) {

                        caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                    }
                });
            });
        }
    } else {

        // 如果点击的是人员,刷新模版
        if (commonView.initParams.selectType == 1) {

            var searchPersonnelHistory = JSON.parse(localStorage.getItem("searchPersonnelHistory"));

            if (caac.util.isNotEmpty(searchPersonnelHistory)) {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_personnel_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate(searchPersonnelHistory));
            } else {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_none_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate);
            }

        } else if (commonView.initParams.selectType == 2) {

            var searchUnitHistory = JSON.parse(localStorage.getItem("searchUnitHistory"));

            if (caac.util.isNotEmpty(searchUnitHistory)) {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_unit_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate(searchUnitHistory));
            } else {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_none_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate);
            }
        }
    }
};


/**
 * 点击选中数据
 */
commonView.onSelect = function (no, name) {

    var selectedItem = {no: no, name: name};

    // 更新历史记录
    if (commonView.initParams.selectType == 1) {
        // 设置历史记录
        var searchPersonnelHistory = JSON.parse(localStorage.getItem("searchPersonnelHistory"));

        if (searchPersonnelHistory == null) {

            var searchPersonnelHistoryArray = new Array();

            searchPersonnelHistoryArray.push(selectedItem);

            localStorage.setItem("searchPersonnelHistory", JSON.stringify(searchPersonnelHistoryArray));
        } else if (searchPersonnelHistory.length < 10) {

            for (let i = 0; i < searchPersonnelHistory.length; i++) {
                if (JSON.stringify(searchPersonnelHistory[i]) == JSON.stringify(selectedItem)) {
                    searchPersonnelHistory.splice(i, 1);
                    break;
                }
            }

            searchPersonnelHistory.push(selectedItem);

            localStorage.setItem("searchPersonnelHistory", JSON.stringify(searchPersonnelHistory));
        } else {

            var bl = true;

            for (let i = 0; i < searchPersonnelHistory.length; i++) {
                if (JSON.stringify(searchPersonnelHistory[i]) == JSON.stringify(selectedItem)) {
                    searchPersonnelHistory.splice(i, 1);
                    bl = false;
                    break;
                }
            }

            if (bl) {
                searchPersonnelHistory.shift();
            }

            searchPersonnelHistory.push(selectedItem);

            localStorage.setItem("searchPersonnelHistory", JSON.stringify(searchPersonnelHistory));
        }
    } else if ((commonView.initParams.selectType == 2)) {
        // 设置历史记录
        var searchUnitHistory = JSON.parse(localStorage.getItem("searchUnitHistory"));

        if (searchUnitHistory == null) {

            var searchUnitHistoryArray = new Array();

            searchUnitHistoryArray.push(selectedItem);

            localStorage.setItem("searchUnitHistory", JSON.stringify(searchUnitHistoryArray));
        } else if (searchUnitHistory.length < 10) {

            for (let i = 0; i < searchUnitHistory.length; i++) {
                if (JSON.stringify(searchUnitHistory[i]) == JSON.stringify(selectedItem)) {
                    searchUnitHistory.splice(i, 1);
                    break;
                }
            }

            searchUnitHistory.push(selectedItem);

            localStorage.setItem("searchUnitHistory", JSON.stringify(searchUnitHistory));
        } else {

            var bl = true;

            for (let i = 0; i < searchUnitHistory.length; i++) {
                if (JSON.stringify(searchUnitHistory[i]) == JSON.stringify(selectedItem)) {
                    searchUnitHistory.splice(i, 1);
                    bl = false;
                    break;
                }
            }

            if (bl) {
                searchUnitHistory.shift();
            }

            searchUnitHistory.push(selectedItem);

            localStorage.setItem("searchUnitHistory", JSON.stringify(searchUnitHistory));
        }
    }

    // 查看点击的数据是否重复选中
    var bl = true;
    var addresseeStrArr = commonView.initParams.bean.addresseeStrArr;
    var addressee = commonView.initParams.bean.addressee;
    for (let i = 0; i < addresseeStrArr.length; i++) {

        if (addresseeStrArr[i].no == no) {

            bl = false;
            break;
        }
    }

    // 如果没有重复选中
    if (bl) {

        if (commonView.initParams.selectType == 1) {

            var personnelTemplate = kendo.template($(".fj-common-container #tmplt_selected_personnel").html());

            // 将数据放入模板并显示在对应位置
            $(".fj-common-container .fj-selected-list").append(personnelTemplate(selectedItem));

        } else if (commonView.initParams.selectType == 2) {

            var unitTemplate = kendo.template($(".fj-common-container #tmplt_selected_unit").html());

            // 将数据放入模板并显示在对应位置
            $(".fj-common-container .fj-selected-list").append(unitTemplate(selectedItem));
        }

        commonView.viewModel.set("count", commonView.viewModel.get("count") + 1);
        addresseeStrArr.push(selectedItem);

        if (caac.util.isNotBlank(addressee)) {

            commonView.initParams.bean.addressee = addressee + "," + no;

        } else {

            commonView.initParams.bean.addressee = no;
        }

    } else {

        caac.guiframe.showMessage("请勿重复选择", caac.constants.messageTypes.WARNING);
    }

};

/**
 * 点击选择查询类型
 */
commonView.onChangeSelectType = function (event, selectType) {

    // 如果点击的不是已选中的查询类型
    if (commonView.initParams.selectType != selectType) {

        // 设置新的查询类型
        commonView.initParams.selectType = selectType;

        // 改变样式
        $(".fj-common-container .fj-category-panel .fj-category-item").removeClass("fj-selected");
        $(event.currentTarget).addClass("fj-selected");

        // 如果点击的是人员,刷新模版
        if (commonView.initParams.selectType == 1) {

            var searchPersonnelHistory = JSON.parse(localStorage.getItem("searchPersonnelHistory"));

            if (caac.util.isNotEmpty(searchPersonnelHistory)) {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_personnel_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate(searchPersonnelHistory));
            } else {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_none_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate);
            }

        } else if (commonView.initParams.selectType == 2) {

            var searchUnitHistory = JSON.parse(localStorage.getItem("searchUnitHistory"));

            if (caac.util.isNotEmpty(searchUnitHistory)) {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_unit_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate(searchUnitHistory));
            } else {

                // 取得视图模版
                var gridTemplate = kendo.template($(".fj-common-container #tmplt_none_history").html());
                // 设置列表视图内容
                $(".fj-common-container #dv_recent_result").html(gridTemplate);
            }
        }
    }
};

/**
 * 点击删除
 */
commonView.onDelete = function (no) {

    var addresseeStrArr = commonView.initParams.bean.addresseeStrArr;
    var addresseeArr = [];

    // 将所选数据从数据源中删除
    for (var i = addresseeStrArr.length - 1; i >= 0; i--) {
        if (addresseeStrArr[i].no == no) {
            addresseeStrArr.splice(i, 1);
        } else {
            addresseeArr.push(addresseeStrArr[i].no);
        }
    }

    commonView.initParams.bean.addresseeStrArr = addresseeStrArr;
    commonView.initParams.bean.addressee = addresseeArr.join(",");

    commonView.viewModel.set("count", commonView.viewModel.get("count") - 1);

    $(".fj-common-container .fj-selected-list #" + no).remove();
};