// 获取页面对象
var homeView = caac.guiframe.getView("home");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 控件初始化
    homeView.initWidgets();
    // 事件初始化
    homeView.initEvents();
}

/**
 * 初始化控件
 */
homeView.initWidgets = function () {

    if (localStorage.getItem("msgCount") != 0 || localStorage.getItem("versionUpdate") === "1") {

        document.getElementById("dv_notif_hint").className = "fj-notif-hint";
    }

    window.JPush.init();
};

/**
 * 初始化绑定事件
 */
homeView.initEvents = function () {

    // 绑定点击紧急事件管理
    $(".fj-home-container #dv-event").bind("click", function () {
        // 跳转到事件报告收件箱所需参数
        homeView.unsafeevent = {};
        homeView.unsafeevent.eventType = 1;
        homeView.onCheck("eventlist", homeView.unsafeevent);
    });

    // 绑定点击站内信息
    $(".fj-home-container #dv-innermail").bind("click", function () {

        //跳转到收件箱所需参数
        homeView.innermail = {};
        homeView.innermail.mailType = 1;

        homeView.onCheck("innermaillist", homeView.innermail);
    });

    // 绑定点击共享信息
    $(".fj-home-container #dv-information").bind("click", function () {

        homeView.news = {};
        homeView.news.newsType = 2;

        homeView.onCheck("informationlist", homeView.news);
    });

    // 绑定点击新闻公告
    $(".fj-home-container #dv-news").bind("click", function () {

        homeView.news = {};
        homeView.news.newsType = 1;

        caac.guiframe.switchView("informationlist", homeView.news, null, ".fj-content-container");
    });

    // 绑定点击工作动态
    $(".fj-home-container #dv-schedule").bind("click", function () {

        homeView.onCheck("workdynamics", null);
    });

    // 绑定点击紧急事件
    $(".fj-home-container #dv-event-fill").bind("click", function () {

        homeView.event = {};
        homeView.event.backPage = "home";
        homeView.event.isCommon = 0;
        homeView.onCheck("eventform", homeView.event);
    });

    // 绑定点击个人信息
    $(".fj-home-container #dv-personal").bind("click", function () {
        homeView.onCheck("personal", null);
    });
};

/**
 * 需要登录验证的跳转
 */
homeView.onCheck = function (name, args) {

    if (localStorage.getItem("loginStatus") != null && localStorage.getItem("loginStatus") === "1") {

        if (localStorage.getItem("isLimit") === "1" && name === "informationlist" && homeView.news.newsType === "2") {

            caac.guiframe.showMessage("此模块暂未开放", caac.constants.messageTypes.WARNING);
            return false;
        }

        // 登陆成功跳转到首页
        caac.guiframe.switchView(name, args, null, ".fj-content-container");
    } else {

        // 未登陆，跳到登陆页面
        caac.guiframe.switchView("login", null, null, ".fj-content-container");
    }
};