// 获取试图信息
var innermaildetailView = caac.guiframe.getView("innermaildetail");

/*
 * 打开视图方法
 * */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化参数
    innermaildetailView.initParams = args;
    innermaildetailView.returnListParams = {};
    innermaildetailView.returnListParams.mailType = innermaildetailView.initParams.mailType;

    // 初始化控件
    innermaildetailView.initWidgets();
    // 初始化数据
    innermaildetailView.initData();
    // 初始化事件
    innermaildetailView.initEvents();
}

/*
 * 初始化控件
 * */
innermaildetailView.initWidgets = function () {

    innermaildetailView.viewModel = kendo.observable({
        innermailBean: {},
        mailNo: null,
        sender: null,
        senderName: null,
        mailToArr: [],
        mailTo: null,
        mailToName: null,
        mailCcArr: [],
        mailCc: null,
        mailCcName: null,
        subject: null,
        content: null,
        attachments: null,
        attachmentsArr: [],
        attachmentsTmpPath: null,
        mailOption: null,
        mailOptionArr: [],
        sendDate: null,
        sendDateStr: null,
        status: 1 //1：已发送；2：待发送；3：草稿
    });

    kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);

    //渲染发布时间插件
    $("#tp_send_date").kendoDateTimePicker({
        interval: 30,
        animation: {
            close: {
                effects: "fadeOut zoom:out",
                duration: 300
            },
            open: {
                effects: "fadeIn zoom:in",
                duration: 300
            }
        }
    });

    //拖拽功能
    // 初始化拖放对象
    $(".fj-mail-detail-panel .fj-button-bar").kendoDraggable({
        hint: function (element) {

            // 返回拖放对象
            //return $(".fj-mail-detail-panel .fj-button-bar").clone().css("opacity", "0.25");
            return element.clone().css("opacity", "0");
        },
        dragstart: function (event) {

        },
        dragend: function (event) {

            // 取得筛选条件对象
            var draggable = $(".fj-mail-detail-panel .fj-button-bar").data("kendoDraggable");
            // 设置传输列表上方位置
            $(".fj-mail-detail-panel .fj-button-bar").css("top", draggable.hintOffset.top);
            // 设置传输列表左方位置
            $(".fj-mail-detail-panel .fj-button-bar").css("left", draggable.hintOffset.left);
        }
    });

    // 初始化拖放目标对象
    $("body").kendoDropTarget({
        dragenter: function (event) {
        },
        dragleave: function (event) {
        },
        drop: function (event) {
        }
    });

    //渲染富文本编辑器控件
    innermaildetailView.editor = $(".fj-mail-detail-panel #editor").kendoEditor({
        tools: []
    }).data("kendoEditor");

    $("textarea.fj-editor").closest("table.k-editor").addClass("fj-editor");
};

/*
 * 初始化数据
 * */
innermaildetailView.initData = function () {

    caac.guiframe.showScreenPanel();

    // 不是从共通页面返回
    if (innermaildetailView.initParams.isCommon == 0) {

        // 发送请求获取各个控件的初始数据
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/initdata.act", innermaildetailView.initParams, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {
                    if (caac.util.isNotEmpty(data.bean)) {

                        // 设置未读消息
                        if (innermaildetailView.initParams.isConfirmed == 0) {

                            var msgCount = localStorage.getItem("msgCount");
                            localStorage.setItem("msgCount", msgCount - 1);
                            cordova.plugins.notification.badge.decrease(1);
                        }

                        var innermailbean = data.bean;
                        innermaildetailView.viewModel.set("innermailBean", innermailbean);
                        innermaildetailView.viewModel.set("mailNo", innermailbean.mailNo);
                        innermaildetailView.viewModel.set("sender", innermailbean.sender);
                        innermaildetailView.viewModel.set("senderName", innermailbean.senderName);
                        innermaildetailView.viewModel.set("mailTo", innermailbean.mailTo);
                        innermaildetailView.viewModel.set("mailToName", innermailbean.mailToName);
                        innermaildetailView.viewModel.set("status", innermailbean.status);
                        innermaildetailView.viewModel.set("subject", innermailbean.subject);
                        innermaildetailView.viewModel.set("content", innermailbean.content);
                        innermaildetailView.viewModel.set("sendDateStr", innermailbean.sendDateStr);

                        var mailToArr = [];
                        var mailToNoArr = innermailbean.mailTo.split(",");
                        var mailToNameArr = innermailbean.mailToName.split("、");
                        for (let index = 0; index < mailToNoArr.length; index++) {
                            var mailTo = {};
                            mailTo.no = mailToNoArr[index];
                            mailTo.name = mailToNameArr[index];
                            mailToArr.push(mailTo);
                        }
                        innermaildetailView.viewModel.set("mailToArr", mailToArr);

                        // 取得主送人模板对象
                        var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_to").html());

                        $(".fj-mail-detail-panel #dv_mail_to").html("");
                        $.each(mailToArr, function (n, value) {
                            // 将数据放入模板并显示在对应位置
                            $(".fj-mail-detail-panel #dv_mail_to").append(headerItemTemplate(value));
                        });

                        //设置 抄送人 初始数据
                        innermaildetailView.viewModel.set("mailCc", innermailbean.mailCc);
                        innermaildetailView.viewModel.set("mailCcName", innermailbean.mailCcName);

                        var mailCcArr = [];
                        if (caac.util.isNotBlank(innermailbean.mailCc)) {
                            var mailCcNoArr = innermailbean.mailCc.split(",")
                            var mailCcNameArr = innermailbean.mailCcName.split("、");
                            for (let index = 0; index < mailCcNoArr.length; index++) {
                                var mailCc = {};
                                mailCc.no = mailCcNoArr[index];
                                mailCc.name = mailCcNameArr[index];
                                mailCcArr.push(mailCc);
                            }
                        }
                        innermaildetailView.viewModel.set("mailCcArr", mailCcArr);
                        // 取得主送人模板对象
                        var headerItemTemplate2 = kendo.template($(".fj-mail-detail-panel #tmplt_mail_cc").html());

                        $(".fj-mail-detail-panel #dv_mail_cc").html("");
                        $.each(mailCcArr, function (n, value) {
                            // 将数据放入模板并显示在对应位置
                            $(".fj-mail-detail-panel #dv_mail_cc").append(headerItemTemplate2(value));
                        });

                        // 附件
                        if (caac.util.isNotEmpty(data.fileList)) {
                            // 记录历史数据
                            innermaildetailView.viewModel.set("attachmentsArr", data.fileList);

                            // 取得附件列表控件模板
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

                            var tmpPathArr = [];
                            $.each(data.fileList, function (n, value) {
                                // 将新的页头添加到导航控件中
                                $(".fj-mail-detail-panel .fj-mail-attachments").append(headerItemTemplate(value));
                                tmpPathArr.push(value.filePath);
                            });
                            innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));
                        }

                        // 定时发送和紧急发送
                        var mailOptionArr = data.mailOptionList;

                        localStorage.setItem("mailOptionList", JSON.stringify(data.mailOptionList));

                        var mailOptionHtml = "";
                        if (caac.util.isNotEmpty(mailOptionArr)) {
                            for (let index = 0; index < mailOptionArr.length; index++) {
                                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
                            }
                        }
                        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

                        if (caac.util.isNotBlank(data.bean.mailOption)) {

                            innermaildetailView.viewModel.set("mailOptionArr", data.bean.mailOption.split(","));
                        }

                        innermaildetailView.viewModel.set("sendDate", new Date(data.bean.sendDate));

                        kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);

                        //是否显示时间控件
                        innermaildetailView.onChangedMailOption_handler();
                    } else {

                        // 如果bean没有数据则为新发邮件
                        innermaildetailView.viewModel.set("sender", data.sender);
                        innermaildetailView.viewModel.set("senderName", data.senderName);
                        innermaildetailView.viewModel.set("content", data.content);

                        // 定时发送和紧急发送
                        var mailOptionArr = data.mailOptionList;
                        var mailOptionHtml = "";
                        if (caac.util.isNotEmpty(mailOptionArr)) {
                            for (let index = 0; index < mailOptionArr.length; index++) {
                                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
                            }
                        }
                        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

                        //是否显示时间控件
                        innermaildetailView.onChangedMailOption_handler();
                    }

                    // 设置可视元素
                    innermaildetailView.initSpecialWidgets();

                    caac.guiframe.hideScreenPanel();
                },
                error: function (data) {

                    caac.guiframe.hideScreenPanel();

                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    } else if (innermaildetailView.initParams.isCommon == 1) {

        // 从共通页面返回
        var innermailbean = innermaildetailView.initParams.bean;
        innermaildetailView.viewModel.set("innermailBean", innermailbean);
        innermaildetailView.viewModel.set("mailNo", innermailbean.mailNo);
        innermaildetailView.viewModel.set("sender", innermailbean.sender);
        innermaildetailView.viewModel.set("senderName", innermailbean.senderName);
        innermaildetailView.viewModel.set("status", innermailbean.status);
        innermaildetailView.viewModel.set("subject", innermailbean.subject);
        innermaildetailView.viewModel.set("content", innermailbean.content);
        innermaildetailView.viewModel.set("sendDateStr", innermailbean.sendDateStr);


        //  是否返回了选择主送人
        if (innermaildetailView.initParams.callbackData == 1) {

            innermaildetailView.viewModel.set("mailToArr", innermailbean.addresseeStrArr);
            innermaildetailView.viewModel.set("mailTo", innermailbean.addressee);

            // 取得主送人模板对象
            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_to").html());

            $(".fj-mail-detail-panel #dv_mail_to").html("");

            $.each(innermailbean.addresseeStrArr, function (n, value) {
                // 将数据放入模板并显示在对应位置
                $(".fj-mail-detail-panel #dv_mail_to").append(headerItemTemplate(value));
            });

            //设置抄送人数据
            innermaildetailView.viewModel.set("mailCc", innermailbean.mailCc);
            innermaildetailView.viewModel.set("mailCcArr", innermailbean.mailCcArr);

            // 取得抄送人模板对象
            headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_cc").html());

            $(".fj-mail-detail-panel #dv_mail_cc").html("");
            $.each(innermailbean.mailCcArr, function (n, value) {
                // 将数据放入模板并显示在对应位置
                $(".fj-mail-detail-panel #dv_mail_cc").append(headerItemTemplate(value));
            });

        } else if (innermaildetailView.initParams.callbackData == 2) {

            innermaildetailView.viewModel.set("mailCc", innermailbean.addressee);
            innermaildetailView.viewModel.set("mailCcArr", innermailbean.addresseeStrArr);

            // 取得抄送人模板对象
            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_cc").html());

            $(".fj-mail-detail-panel #dv_mail_cc").html("");
            $.each(innermailbean.addresseeStrArr, function (n, value) {
                // 将数据放入模板并显示在对应位置
                $(".fj-mail-detail-panel #dv_mail_cc").append(headerItemTemplate(value));
            });

            innermaildetailView.viewModel.set("mailTo", innermailbean.mailTo);
            innermaildetailView.viewModel.set("mailToArr", innermailbean.mailToArr);

            // 取得主送人模板对象
            headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_to").html());

            $(".fj-mail-detail-panel #dv_mail_to").html("");

            $.each(innermailbean.mailToArr, function (n, value) {
                // 将数据放入模板并显示在对应位置
                $(".fj-mail-detail-panel #dv_mail_to").append(headerItemTemplate(value));
            });
        }

        // 附件
        if (innermailbean.attachmentList.length != 0) {
            // 记录历史数据
            innermaildetailView.viewModel.set("attachmentsArr", innermailbean.attachmentList);

            // 取得附件列表控件模板
            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

            var tmpPathArr = [];
            $.each(innermailbean.attachmentList, function (n, value) {
                // 将新的页头添加到导航控件中
                $(".fj-mail-detail-panel .fj-mail-attachments").append(headerItemTemplate(value));
                tmpPathArr.push(value.filePath);
            });
            innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));
        }

        // 定时发送和紧急发送
        var mailOptionArr = JSON.parse(localStorage.getItem("mailOptionList"));

        var mailOptionHtml = "";
        if (caac.util.isNotEmpty(mailOptionArr)) {
            for (let index = 0; index < mailOptionArr.length; index++) {
                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
            }
        }

        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

        if (caac.util.isNotBlank(innermailbean.mailOption)) {

            innermaildetailView.viewModel.set("mailOptionArr", innermailbean.mailOption.split(","));
        }

        innermaildetailView.viewModel.set("sendDate", innermailbean.sendDate);

        kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);

        //是否显示时间控件
        innermaildetailView.onChangedMailOption_handler();

        // 设置可视元素
        innermaildetailView.initSpecialWidgets();

        caac.guiframe.hideScreenPanel();
    }
};

/**
 * 删除所选主送人
 */
innermaildetailView.onRemoveMailToClicked = function (event) {

    // 获取选中项
    var selecedItem = $(event.target.parentElement);
    // 改变所选主送人结果
    var mailToArr = innermaildetailView.viewModel.get("mailToArr");
    var mailToNoArr = [];

    // 将所选数据从数据源中删除
    for (let i = mailToArr.length - 1; i >= 0; i--) {
        if (mailToArr[i].no == selecedItem.prop("id")) {
            mailToArr.splice(i, 1);
        } else {
            mailToNoArr.push(mailToArr[i].no);
        }
    }
    innermaildetailView.viewModel.set("mailToArr", mailToArr);
    innermaildetailView.viewModel.set("mailTo", mailToNoArr.join(","));

    // 从页面上删除选中项
    selecedItem.remove();
    // 阻止事件冒泡
    event.stopPropagation();

};

/**
 * 删除所选抄送人
 */
innermaildetailView.onRemoveMailCcClicked = function (event) {

    // 获取选中项
    var selecedItem = $(event.target.parentElement);
    // 改变所选主送人结果
    var mailCcArr = innermaildetailView.viewModel.get("mailCcArr");
    var mailCcNoArr = [];

    // 将所选数据从数据源中删除
    for (let i = mailCcArr.length - 1; i >= 0; i--) {
        if (mailCcArr[i].no == selecedItem.prop("id")) {
            mailCcArr.splice(i, 1);
        } else {
            mailCcNoArr.push(mailCcArr[i].no);
        }
    }
    innermaildetailView.viewModel.set("mailCcArr", mailCcArr);
    innermaildetailView.viewModel.set("mailCc", mailCcNoArr.join(","));

    // 从页面上删除选中项
    selecedItem.remove();
    // 阻止事件冒泡
    event.stopPropagation();

};

/**
 * 删除所选附件
 */
innermaildetailView.onRemoveAttachmentsClicked = function (event) {

    var selecedItem = $(event.target.parentElement.parentElement.parentElement.parentElement);
    // 改变所选附件结果
    var attaArr = innermaildetailView.viewModel.get("attachmentsArr");
    // 将所选数据从数据源中删除
    for (let i = attaArr.length - 1; i >= 0; i--) {
        if (attaArr[i].checkSum == selecedItem.prop("id") || attaArr[i].fileName == $(event.target).html()) {
            attaArr.splice(i, 1);
        }
    }
    innermaildetailView.viewModel.set("attachmentsArr", attaArr);

    // 重新组织所选附件路径
    var tmpPathArr = [];
    $.each(attaArr, function (n, value) {
        tmpPathArr.push(value.filePath);
    });
    innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));

    // 从页面上删除选中项
    selecedItem.remove();
    // 阻止事件冒泡
    event.stopPropagation();

};

/**
 * 下载附件
 */
innermaildetailView.onViewAttachmentClicked = function onViewAttachmentClicked(checkSum, fileName) {

    cordova.InAppBrowser.open(encodeURI(encodeURI(caac.constants.httpHead.URLHEAD + "innermaildetail/download.act?checkSum=" + checkSum + "&fileName=" + fileName)),'_system');
};

/**
 * 选择人员
 */
innermaildetailView.selectPersonnel = function (callbackData) {

    // 加载共通页面所需参数
    innermaildetailView.common = innermaildetailView.initParams;
    innermaildetailView.common.commonType = 1;
    innermaildetailView.common.viewName = "innermaildetail";

    // 返回的数据是什么类型(收件人1/抄送人2)
    innermaildetailView.common.callbackData = callbackData;

    var addresseeStrArr = [];
    var addressee = null;

    if (callbackData == 1) {

        addressee = innermaildetailView.viewModel.get("mailTo");
        addresseeStrArr = innermaildetailView.viewModel.get("mailToArr");
    } else if (callbackData == 2) {

        addressee = innermaildetailView.viewModel.get("mailCc");
        addresseeStrArr = innermaildetailView.viewModel.get("mailCcArr");
    }

    // 保存站内信页面信息用于返回
    var innerMailBean = {
        mailNo: innermaildetailView.viewModel.get("mailNo"),
        sender: innermaildetailView.viewModel.get("sender"),
        senderName: innermaildetailView.viewModel.get("senderName"),
        mailTo: innermaildetailView.viewModel.get("mailTo"),
        mailToArr: innermaildetailView.viewModel.get("mailToArr"),
        status: innermaildetailView.viewModel.get("status"),
        subject: innermaildetailView.viewModel.get("subject"),
        content: innermaildetailView.editor.value(),
        sendDateStr: innermaildetailView.viewModel.get("sendDateStr"),
        mailCc: innermaildetailView.viewModel.get("mailCc"),
        mailCcArr: innermaildetailView.viewModel.get("mailCcArr"),
        attachmentList: innermaildetailView.viewModel.get("attachmentsArr"),
        mailOption: innermaildetailView.viewModel.get("mailOptionArr").join(","),
        sendDate: innermaildetailView.viewModel.get("sendDate"),
        addressee: addressee,
        addresseeStrArr: addresseeStrArr
    };

    innermaildetailView.common.bean = innerMailBean;

    caac.guiframe.switchView("common", innermaildetailView.common, null, ".fj-content-container");
};

/**
 * 设置按钮可见性与可编辑性
 */
innermaildetailView.initSpecialWidgets = function () {

    var subject = innermaildetailView.viewModel.get("subject");

    if (innermaildetailView.initParams.mailType == 1) {

        // 收件箱
        $(".fj-mail-detail-panel #dv_reply").removeClass("fj-hidden");
        $(".fj-mail-detail-panel #replyAll").removeClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_forwarding").removeClass("fj-hidden");
        // 设置kendo编辑器不可编辑
        innermaildetailView.editor.document.body.contentEditable = false;

        document.getElementById("dv_have_title").className = "";
        document.getElementById("dv_none_title").className = "fj-hidden";

    } else if (innermaildetailView.initParams.mailType == 2) {

        // 发件箱
        $(".fj-mail-detail-panel #dv_forwarding").removeClass("fj-hidden");
        // 设置kendo编辑器不可编辑
        innermaildetailView.editor.document.body.contentEditable = false;

        document.getElementById("dv_have_title").className = "";
        document.getElementById("dv_none_title").className = "fj-hidden";

    } else if (innermaildetailView.initParams.mailType == 3) {

        // 待发送
        $(".fj-mail-detail-panel #dv_edit").removeClass("fj-hidden");
        // 设置kendo编辑器不可编辑
        innermaildetailView.editor.document.body.contentEditable = false;

        document.getElementById("dv_have_title").className = "";
        document.getElementById("dv_none_title").className = "fj-hidden";

    } else if (innermaildetailView.initParams.mailType == 4) {

        // 草稿箱
        $(".fj-mail-detail-panel #dv_edit").removeClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_send").removeClass("fj-hidden");
        // 设置kendo编辑器不可编辑
        innermaildetailView.editor.document.body.contentEditable = false;

        document.getElementById("dv_have_title").className = "";
        document.getElementById("dv_none_title").className = "fj-hidden";

    } else if (innermaildetailView.initParams.mailType == 5) {

        // 新建
        $(".fj-mail-detail-panel #dv_send").removeClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_save").removeClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_reply").addClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_replyAll").addClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_forwarding").addClass("fj-hidden");
        $(".fj-mail-detail-panel #dv_edit").addClass("fj-hidden");
        $(".fj-mail-detail-panel #dv-add-attachments").removeClass("fj-hidden");
        // 显示删除标签
        $(".fj-mail-detail-panel .fa-times").removeClass("fj-hidden");
        $(".fj-mail-detail-panel .fa-plus").removeClass("fj-hidden");
        //显示发送选项
        $(".fj-mail-detail-panel .fj-label-value").removeClass("fj-hidden");
        // 设置kendo编辑器可编辑
        innermaildetailView.editor.document.body.contentEditable = true;

        document.getElementById("dv_have_title").className = "fj-hidden";
        document.getElementById("dv_none_title").className = "";
    }
};

/**
 * 当发送选项为定时发送时，显示选择日期空间
 */
innermaildetailView.onChangedMailOption_handler = function () {

    if ($("#mailOption_2").is(':checked')) {
        //显示时间控件
        $("#div_sendDate").css("display", "block");
        //设置邮件状态为待发送
        innermaildetailView.viewModel.set("status", 2);
    } else {
        $("#div_sendDate").css("display", "none");
        //设置邮件状态为立即发送
        innermaildetailView.viewModel.set("status", 1);
    }
};

/**
 * 初始化事件
 */
innermaildetailView.initEvents = function () {

    // 绑定文件按钮
    $(".fj-mail-detail-panel #dv-add-attachments").bind("click", function () {

        var change = document.getElementById("dv-attachments-list");

        if (change != undefined && change != null) {

            if (change.className.indexOf("fj-hidden") == -1) {
                change.className = "fj-hidden";
            } else {
                change.className = "";
            }
        }
    });

    // 点击返回一览页面
    $(".fj-mail-detail-panel #dv_return_listpage").bind("click", function () {

        innermaildetailView.returnListPage();
    });

    // 点击回复
    $(".fj-mail-detail-panel #dv_reply").bind("click", function () {

        innermaildetailView.initParams.mailType = 5;

        caac.guiframe.showScreenPanel();
        //发送请求获取各个控件的初始数据
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/reply.act", innermaildetailView.initParams, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {
                    if (caac.util.isNotEmpty(data)) {
                        /*********start  自动填充邮件的发送人，主送人，抄送人**********/
                        if (caac.util.isNotEmpty(data.bean)) {
                            var innermailbean = data.bean;
                            innermaildetailView.viewModel.set("mailNo", null);
                            innermaildetailView.viewModel.set("sender", innermailbean.sender);
                            innermaildetailView.viewModel.set("senderName", innermailbean.senderName);
                            innermaildetailView.viewModel.set("mailTo", innermailbean.mailTo);
                            innermaildetailView.viewModel.set("mailToName", innermailbean.mailToName);
                            //设置发送时间为null,并隐藏div
                            $(".fj-mail-detail-panel #dv-sendDateStr").addClass("fj-hidden");
                            innermaildetailView.viewModel.set("sendDateStr", null);
                            var mailToArr = [];
                            var mailToNoArr = innermailbean.mailTo.split(",");
                            var mailToNameArr = innermailbean.mailToName.split("、");
                            for (let index = 0; index < mailToNoArr.length; index++) {
                                var mailTo = {};
                                mailTo.no = mailToNoArr[index];
                                mailTo.name = mailToNameArr[index];
                                mailToArr.push(mailTo);
                            }
                            innermaildetailView.viewModel.set("mailToArr", mailToArr);
                            // 取得主送人模板对象
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_to").html());
                            $(".fj-mail-detail-panel #dv_mail_to").html("");
                            $.each(mailToArr, function (n, value) {
                                // 将数据放入模板并显示在对应位置
                                $(".fj-mail-detail-panel #dv_mail_to").append(headerItemTemplate(value));
                            });

                            // 清空抄送人
                            innermaildetailView.viewModel.set("mailCc", null);
                            innermaildetailView.viewModel.set("mailCcName", null);
                            innermaildetailView.viewModel.set("mailCcArr", []);
                            $(".fj-mail-detail-panel #dv_mail_cc").html("");

                            innermaildetailView.viewModel.set("subject", innermailbean.subject);
                            innermaildetailView.viewModel.set("content", innermailbean.content);

                        }
                        /*********end  自动填充邮件的发送人，主送人，抄送人**********/

                        /*********start 回复邮件的附件**********/
                        if (caac.util.isNotEmpty(data.fileList)) {

                            $(".fj-mail-detail-panel .fj-attachments").html("");

                            //记录历史数据
                            innermaildetailView.viewModel.set("attachmentsArr", data.fileList);

                            // 取得附件列表控件模板
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

                            var tmpPathArr = [];
                            $.each(data.fileList, function (n, value) {

                                // 将新的页头添加到导航控件中
                                $(".fj-mail-detail-panel .fj-attachments").append(headerItemTemplate(value));
                                tmpPathArr.push(value.filePath);
                            });
                            innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));

                        }
                        /*********end 显示邮件的附件**********/

                            // 定时发送和紧急发送
                        var mailOptionArr = data.mailOptionList;
                        var mailOptionHtml = "";
                        if (caac.util.isNotEmpty(mailOptionArr)) {
                            for (let index = 0; index < mailOptionArr.length; index++) {
                                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
                            }
                        }
                        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

                        if (caac.util.isNotEmpty(data.bean)) {
                            if (caac.util.isNotBlank(data.bean.mailOption)) {
                                if (data.bean.mailOption == 2) {
                                    innermaildetailView.viewModel.set("sendDate", new Date(data.bean.sendDate));
                                }
                                innermaildetailView.viewModel.set("mailOptionArr", data.bean.mailOption.split(","));
                            }
                        }

                        kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);
                        //是否显示时间控件
                        innermaildetailView.onChangedMailOption_handler();
                        /*********end 设置发送选项**********/

                    }
                    innermaildetailView.initSpecialWidgets();

                    caac.guiframe.hideScreenPanel();
                },
                error: function (data) {

                    caac.guiframe.hideScreenPanel();
                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    });

    // 点击回复全部
    $(".fj-mail-detail-panel #dv_replyAll").bind("click", function () {

        innermaildetailView.initParams.mailType = 5;

        caac.guiframe.showScreenPanel();

        //发送请求获取各个控件的初始数据
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/replyall.act", innermaildetailView.initParams, function (result) {

            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {
                    if (caac.util.isNotEmpty(data)) {
                        /*********start  自动填充邮件的发送人，主送人，抄送人**********/
                        if (caac.util.isNotEmpty(data.bean)) {
                            var innermailbean = data.bean;
                            innermaildetailView.viewModel.set("mailNo", null);
                            innermaildetailView.viewModel.set("sender", innermailbean.sender);
                            innermaildetailView.viewModel.set("senderName", innermailbean.senderName);
                            innermaildetailView.viewModel.set("mailTo", innermailbean.mailTo);
                            innermaildetailView.viewModel.set("mailToName", innermailbean.mailToName);
                            //设置发送时间为null,并隐藏div
                            $(".fj-mail-detail-panel #dv-sendDateStr").addClass("fj-hidden");
                            innermaildetailView.viewModel.set("sendDateStr", null);
                            var mailToArr = [];
                            var mailToNoArr = innermailbean.mailTo.split(",")
                            var mailToNameArr = innermailbean.mailToName.split("、");
                            for (let index = 0; index < mailToNoArr.length; index++) {
                                var mailTo = {};
                                mailTo.no = mailToNoArr[index];
                                mailTo.name = mailToNameArr[index];
                                mailToArr.push(mailTo);
                            }
                            innermaildetailView.viewModel.set("mailToArr", mailToArr);
                            // 取得主送人模板对象
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_to").html());

                            $(".fj-mail-detail-panel #dv_mail_to").html("");
                            $.each(mailToArr, function (n, value) {
                                // 将数据放入模板并显示在对应位置
                                $(".fj-mail-detail-panel #dv_mail_to").append(headerItemTemplate(value));
                            });

                            //设置 抄送人 初始数据
                            innermaildetailView.viewModel.set("mailCc", innermailbean.mailCc);
                            innermaildetailView.viewModel.set("mailCcName", innermailbean.mailCcName);
                            var mailCcArr = [];
                            if (caac.util.isNotBlank(innermailbean.mailCc)) {
                                var mailCcNoArr = innermailbean.mailCc.split(",")
                                var mailCcNameArr = innermailbean.mailCcName.split("、");
                                for (let index = 0; index < mailCcNoArr.length; index++) {
                                    var mailCc = {};
                                    mailCc.no = mailCcNoArr[index];
                                    mailCc.name = mailCcNameArr[index];
                                    mailCcArr.push(mailCc);
                                }
                            }
                            innermaildetailView.viewModel.set("mailCcArr", mailCcArr);
                            // 取得抄送人模板对象
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_mail_cc").html());
                            $(".fj-mail-detail-panel #dv_mail_cc").html("");
                            $.each(mailCcArr, function (n, value) {
                                // 将数据放入模板并显示在对应位置
                                $(".fj-mail-detail-panel #dv_mail_cc").append(headerItemTemplate(value));
                            });

                            innermaildetailView.viewModel.set("subject", innermailbean.subject);
                            innermaildetailView.viewModel.set("content", innermailbean.content);

                        }
                        /*********end  自动填充邮件的发送人，主送人，抄送人**********/

                        /*********start 回复邮件的附件**********/
                        if (caac.util.isNotEmpty(data.fileList)) {

                            $(".fj-mail-detail-panel .fj-attachments").html("");

                            //记录历史数据
                            innermaildetailView.viewModel.set("attachmentsArr", data.fileList);

                            // 取得附件列表控件模板
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

                            var tmpPathArr = [];
                            $.each(data.fileList, function (n, value) {
                                // 将新的页头添加到导航控件中
                                $(".fj-mail-detail-panel .fj-attachments").append(headerItemTemplate(value));
                                tmpPathArr.push(value.filePath);
                            });
                            innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));
                        }
                        /*********end 显示邮件的附件**********/

                            // 定时发送和紧急发送
                        var mailOptionArr = data.mailOptionList;
                        var mailOptionHtml = "";
                        if (caac.util.isNotEmpty(mailOptionArr)) {
                            for (let index = 0; index < mailOptionArr.length; index++) {
                                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
                            }
                        }
                        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

                        if (caac.util.isNotEmpty(data.bean)) {
                            if (caac.util.isNotBlank(data.bean.mailOption)) {
                                if (data.bean.mailOption == 2) {
                                    innermaildetailView.viewModel.set("sendDate", new Date(data.bean.sendDate));
                                }
                                innermaildetailView.viewModel.set("mailOptionArr", data.bean.mailOption.split(","));
                            }
                        }

                        kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);

                        //是否显示时间控件
                        innermaildetailView.onChangedMailOption_handler();
                    }
                    innermaildetailView.initSpecialWidgets();

                    caac.guiframe.hideScreenPanel();
                },
                error: function (data) {

                    caac.guiframe.hideScreenPanel();

                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    });

    // 点击转发
    $(".fj-mail-detail-panel #dv_forwarding").bind("click", function () {
        innermaildetailView.initParams.mailType = 5;

        caac.guiframe.showScreenPanel();
        // 发送请求获取各个控件的初始数据
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/relay.act", innermaildetailView.initParams, function (result) {

            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {
                    if (caac.util.isNotEmpty(data)) {
                        /*********start  自动填充邮件的发送人，主送人，抄送人**********/
                        if (caac.util.isNotEmpty(data.bean)) {
                            var innermailbean = data.bean;
                            innermaildetailView.viewModel.set("mailNo", null);
                            innermaildetailView.viewModel.set("sender", innermailbean.sender);
                            innermaildetailView.viewModel.set("senderName", innermailbean.senderName);

                            // 清空主送人
                            innermaildetailView.viewModel.set("mailTo", null);
                            innermaildetailView.viewModel.set("mailToName", null);
                            innermaildetailView.viewModel.set("mailToArr", []);
                            $(".fj-mail-detail-panel #dv_mail_to").html("");

                            // 清空抄送人
                            innermaildetailView.viewModel.set("mailCc", null);
                            innermaildetailView.viewModel.set("mailCcName", null);
                            innermaildetailView.viewModel.set("mailCcArr", []);
                            $(".fj-mail-detail-panel #dv_mail_cc").html("");

                            innermaildetailView.viewModel.set("subject", innermailbean.subject);
                            innermaildetailView.viewModel.set("content", innermailbean.content);

                            //设置发送时间为null,并隐藏div
                            $(".fj-mail-detail-panel #dv-sendDateStr").addClass("fj-hidden");
                            innermaildetailView.viewModel.set("sendDateStr", null);
                        }
                        /*********end  自动填充邮件的发送人，主送人，抄送人**********/

                        /*********start 回复邮件的附件**********/
                        if (caac.util.isNotEmpty(data.fileList)) {

                            $(".fj-mail-detail-panel .fj-attachments").html("");

                            //记录历史数据
                            innermaildetailView.viewModel.set("attachmentsArr", data.fileList);

                            // 取得附件列表控件模板
                            var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

                            var tmpPathArr = [];
                            $.each(data.fileList, function (n, value) {
                                // 将新的页头添加到导航控件中
                                $(".fj-mail-detail-panel .fj-attachments").append(headerItemTemplate(value));
                                tmpPathArr.push(value.filePath);
                            });
                            innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));
                        }
                        /*********end 显示邮件的附件**********/

                            // 定时发送和紧急发送
                        var mailOptionArr = data.mailOptionList;
                        var mailOptionHtml = "";
                        if (caac.util.isNotEmpty(mailOptionArr)) {
                            for (var index = 0; index < mailOptionArr.length; index++) {
                                var element_id = "mailOption_" + mailOptionArr[index].dataValue;
                                mailOptionHtml += '<input id="' + element_id + '" type="checkbox" onchange="innermaildetailView.onChangedMailOption_handler()" value="' + mailOptionArr[index].dataValue + '" class="k-input" data-bind="checked: mailOptionArr" />' + mailOptionArr[index].abbreviationItemName;
                            }
                        }
                        $(".fj-mail-detail-panel #chkb_mailOption").html(mailOptionHtml);

                        if (caac.util.isNotEmpty(data.bean)) {
                            if (caac.util.isNotBlank(data.bean.mailOption)) {
                                if (data.bean.mailOption == 2) {
                                    innermaildetailView.viewModel.set("sendDate", new Date(data.bean.sendDate));
                                }
                                innermaildetailView.viewModel.set("mailOptionArr", data.bean.mailOption.split(","));
                                kendo.bind($(".fj-mail-detail-panel"), innermaildetailView.viewModel);
                            }
                        }

                        //是否显示时间控件
                        innermaildetailView.onChangedMailOption_handler();
                    }
                    innermaildetailView.initSpecialWidgets();

                    caac.guiframe.hideScreenPanel();
                },
                error: function (data) {

                    caac.guiframe.hideScreenPanel();
                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    });

// 点击编辑
    $(".fj-mail-detail-panel #dv_edit").bind("click", function () {

        innermaildetailView.initParams.mailType = 5;
        innermaildetailView.initSpecialWidgets();
    });

// 点击发送
    $(".fj-mail-detail-panel #dv_send").bind("click", function () {

        innermaildetailView.returnListParams.mailType = 2;
        innermaildetailView.toSave();
    });

// 点击保存
    $(".fj-mail-detail-panel #dv_save").bind("click", function () {

        // 设置状态为保存
        innermaildetailView.viewModel.set("status", 3);
        innermaildetailView.returnListParams.mailType = 4;

        innermaildetailView.toSave();

    });
};

/**
 * 请求服务器保存数据
 */
innermaildetailView.toSave = function () {

    //设置form参数
    var innerMailBean = {
        mailNo: innermaildetailView.viewModel.get("mailNo"),
        sender: innermaildetailView.viewModel.get("sender"),
        mailTo: innermaildetailView.viewModel.get("mailTo"),
        mailCc: innermaildetailView.viewModel.get("mailCc"),
        subject: $(".fj-mail-detail-panel #input_subject").val(),
        content: innermaildetailView.editor.value(),
        attachmentsTmpPath: innermaildetailView.viewModel.get("attachmentsTmpPath"),
        attachmentList: innermaildetailView.viewModel.get("attachmentsArr"),
        mailOption: innermaildetailView.viewModel.get("mailOptionArr").join(","),
        sendDate: innermaildetailView.viewModel.get("sendDate"),
        status: innermaildetailView.viewModel.get("status")
    };

    //校验数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/check.act", {innermail: JSON.stringify(innerMailBean)}, function (data) {

        caac.util.doReturnValue({
            returnValue: data,
            success: function (result) {
                //保存数据
                caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaildetail/save.act", {innermail: JSON.stringify(innerMailBean)}, function (data) {

                    caac.util.doReturnValue({
                        returnValue: data,
                        success: function (result) {

                            if (innermaildetailView.returnListParams.mailType == 4) {

                                caac.guiframe.showMessage("站内信保存成功", caac.constants.messageTypes.SUCCESS);
                            } else {

                                caac.guiframe.showMessage("站内信发送成功", caac.constants.messageTypes.SUCCESS);
                            }
                            innermaildetailView.returnListPage();
                        },
                        error: function (result) {

                            caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
                        }
                    });

                });
            },
            error: function (result) {

                caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
            }
        });

    });
};

/**
 * 返回List页面
 */
innermaildetailView.returnListPage = function () {

    if (innermaildetailView.initParams.returnName == "msghintslist") {

        caac.guiframe.switchView("msghintslist", null, null, ".fj-content-container");
    } else {

        caac.guiframe.switchView("innermaillist", innermaildetailView.returnListParams, null, ".fj-content-container");
    }
};

/**
 * 拍照事件
 */
innermaildetailView.takePicture = function () {

    navigator.camera.getPicture(onSuccess, onFail, {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        encodingType: Camera.EncodingType.PNG,
        cameraDirection: 1
    });

    function onSuccess(imageURL) {

        innermaildetailView.uploadFile(imageURL, caac.constants.httpHead.URLHEAD + "upload/upload.act");
    }

    function onFail(message) {
    }
};

/**
 * 获取手机照片事件
 */
innermaildetailView.getPicture = function () {

    navigator.camera.getPicture(onSuccess, onFail, {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        mediaType: 2
    });

    function onSuccess(imageURL) {

        innermaildetailView.uploadFile(imageURL, caac.constants.httpHead.URLHEAD + "upload/upload.act");
    }

    function onFail(message) {
    }
};

/**
 * 上传文件
 */
innermaildetailView.uploadFile = function (fileURL_, uri_) {

    var fileURL = fileURL_;
    var uri = encodeURI(uri_);
    var options = new FileUploadOptions();

    options.fileKey = "file";
    options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
    options.mimeType = fileURL.substr(fileURL.lastIndexOf('.') + 1);

    var headers = {'headerParam': 'headerValue'};
    options.headers = headers;

    var ft = new FileTransfer();

    ft.upload(fileURL, uri, onSuccess, onError, options);

    function onSuccess(r) {

        if ($(".fj-mail-detail-panel .fj-event-attachments").hasClass("fj-hidden")) {

            $(".fj-mail-detail-panel .fj-event-attachments").removeClass("fj-hidden");
        }

        var data = JSON.parse(r.response).data;
        var attaArr = innermaildetailView.viewModel.get("attachmentsArr");
        var tmpArr = [];

        //获取新增的附件
        $.each(data, function (n, value) {

            //否则判断是否选中了相同的文件，如果有，则去重
            $.each(attaArr, function (m, historyAtta) {
                if (historyAtta.checkSum == value.checkSum && historyAtta.fileName == value.fileName) {
                    attaArr.splice(m, 1);
                    return false;
                }
            });
            tmpArr.push(value);
        });

        //记录所选附件信息
        $.each(tmpArr, function (n, value) {
            attaArr.push(value);
        });

        innermaildetailView.viewModel.set("attachmentsArr", attaArr);

        // 组织所选附件路径
        var tmpPathArr = [];

        innermaildetailView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));

        // 取得附件列表控件模板
        var headerItemTemplate = kendo.template($(".fj-mail-detail-panel #tmplt_attachment_item").html());

        $(".fj-mail-detail-panel .fj-mail-attachments").html("");
        $.each(attaArr, function (n, value) {
            // 将新的页头添加到导航控件中
            $(".fj-mail-detail-panel .fj-mail-attachments").append(headerItemTemplate(value));
        });

        $(".fj-mail-detail-panel .fa-times").removeClass("fj-hidden");
    }

    function onError(error) {

    }
};
