// 获取试图信息
var innermailListView = caac.guiframe.getView("innermaillist");


/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    innermailListView.initParams = args;
    innermailListView.detailParams = {};

    // 初始化控件
    innermailListView.initWidgets();
    // 初始化数据
    innermailListView.initData();
    // 初始化事件
    innermailListView.initEvents();
}

/**
 * 初始化控件
 */
innermailListView.initWidgets = function () {

    innermailListView.viewModel = kendo.observable({
        title: null
    });

    kendo.bind($(".fj-mail-panel"), innermailListView.viewModel);

    //拖拽功能
    // 初始化拖放对象
    $(".fj-mail-panel .fj-button-bar").kendoDraggable({
        hint: function (element) {

            // 返回拖放对象
            return element.clone().css("opacity", "0");
        },
        dragstart: function (event) {

        },
        dragend: function (event) {

            // 取得筛选条件对象
            var draggable = $(".fj-mail-panel .fj-button-bar").data("kendoDraggable");
            // 设置传输列表上方位置
            $(".fj-mail-panel .fj-button-bar").css("top", draggable.hintOffset.top);
            // 设置传输列表左方位置
            $(".fj-mail-panel .fj-button-bar").css("left", draggable.hintOffset.left);
        }
    });

    // 初始化拖放目标对象
    $("body").kendoDropTarget({
        dragenter: function (event) {
        },
        dragleave: function (event) {
        },
        drop: function (event) {
        }
    });
};

/**
 * 初始化数据
 */
innermailListView.initData = function () {

    caac.guiframe.showScreenPanel();

    innermailListView.initParams.pageNum = 1;

    if (innermailListView.initParams.mailType == 2) {
        innermailListView.viewModel.set("title", "发件箱");
    } else if (innermailListView.initParams.mailType == 3) {
        innermailListView.viewModel.set("title", "待发送");
    } else if (innermailListView.initParams.mailType == 4) {
        innermailListView.viewModel.set("title", "草稿箱");
    } else {
        innermailListView.initParams.mailType = 1;
        innermailListView.viewModel.set("title", "收件箱");
    }

    //发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaillist/initdata.act", innermailListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {
                    if (innermailListView.initParams.mailType == 2) {
                        // 取得列表视图模板
                        var outGridTemplate = kendo.template($(".fj-mail-panel #outbox_grid_content").html());
                        // 设置列表视图内容
                        $(".fj-mail-panel .fj-container").html(outGridTemplate(data.list));
                    } else if (innermailListView.initParams.mailType == 3) {
                        // 取得列表视图模板
                        var waitGridTemplate = kendo.template($(".fj-mail-panel #waitbox_grid_content").html());
                        // 设置列表视图内容
                        $(".fj-mail-panel .fj-container").html(waitGridTemplate(data.list));
                    } else if (innermailListView.initParams.mailType == 4) {
                        // 取得列表视图模板
                        var draftGridTemplate = kendo.template($(".fj-mail-panel #draftbox_grid_content").html());
                        // 设置列表视图内容
                        $(".fj-mail-panel .fj-container").html(draftGridTemplate(data.list));
                    } else if (innermailListView.initParams.mailType == 1){
                        // 取得列表视图模板
                        var inGridTemplate = kendo.template($(".fj-mail-panel #inbox_grid_content").html());
                        // 设置列表视图内容
                        $(".fj-mail-panel .fj-container").html(inGridTemplate(data.list));

                        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "msghints/getcount.act", null, function (result) {
                            caac.util.doReturnValue({
                                returnValue: result,
                                success: function (data) {

                                    localStorage.setItem("msgCount", data.msgCount);
                                    cordova.plugins.notification.badge.set(data.msgCount);
                                },
                                error: function (data) {

                                }
                            });
                        });
                    }
                } else {
                    // 取得列表视图模板
                    var noGridTemplate = kendo.template($(".fj-mail-panel #dv_content_nodata").html());
                    // 设置列表视图内容
                    $(".fj-mail-panel .fj-container").html(noGridTemplate);
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};


/**
 * 更多点击事件
 */
innermailListView.onShowMoreClicked = function () {

    innermailListView.initParams.pageNum = parseInt(innermailListView.initParams.pageNum) + 1;

    caac.guiframe.showScreenPanel();

    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "innermaillist/initdata.act", innermailListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {

                    if (innermailListView.initParams.mailType == 1) {
                        var articleGridTemplate = kendo.template($(".fj-mail-panel #inbox_row_content").html());
                        // 循环处理需要增加的数据
                        for (var i = 0, len = data.list.length; i < len; i++) {
                            // 设置列表视图内容
                            $(".fj-mail-panel .fj-container .fj-mail-summary:nth-last-child(2)").after(articleGridTemplate(data.list[i]));
                        }
                        if (data.list.length < 10) {
                            // 设置显示更多按钮不可见
                            $(".fj-mail-panel .fj-show-more").addClass("fj-hidden");
                        }
                    } else if (innermailListView.initParams.mailType == 2) {
                        var articleGridTemplate = kendo.template($(".fj-mail-panel #outbox_row_content").html());
                        // 循环处理需要增加的数据
                        for (var i = 0, len = data.list.length; i < len; i++) {
                            // 设置列表视图内容
                            $(".fj-mail-panel .fj-container .fj-mail-summary:nth-last-child(2)").after(articleGridTemplate(data.list[i]));
                        }
                        if (data.list.length < 10) {
                            // 设置显示更多按钮不可见
                            $(".fj-mail-panel .fj-show-more").addClass("fj-hidden");
                        }
                    } else if (innermailListView.initParams.mailType == 3) {
                        var articleGridTemplate = kendo.template($(".fj-mail-panel #waitbox_row_content").html());
                        // 循环处理需要增加的数据
                        for (var i = 0, len = data.list.length; i < len; i++) {
                            // 设置列表视图内容
                            $(".fj-mail-panel .fj-container .fj-mail-summary:nth-last-child(2)").after(articleGridTemplate(data.list[i]));
                        }
                        if (data.list.length < 10) {
                            // 设置显示更多按钮不可见
                            $(".fj-mail-panel .fj-show-more").addClass("fj-hidden");
                        }
                    } else if (innermailListView.initParams.mailType == 4) {
                        var articleGridTemplate = kendo.template($(".fj-mail-panel #draftbox_row_content").html());
                        // 循环处理需要增加的数据
                        for (var i = 0, len = data.list.length; i < len; i++) {
                            // 设置列表视图内容
                            $(".fj-mail-panel .fj-container .fj-mail-summary:nth-last-child(2)").after(articleGridTemplate(data.list[i]));
                        }
                        if (data.list.length < 10) {
                            // 设置显示更多按钮不可见
                            $(".fj-mail-panel .fj-show-more").addClass("fj-hidden");
                        }
                    }
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 点击事件进入明细
 */
innermailListView.onRowClicked = function (mailNo) {

    innermailListView.detailParams.mailNo = mailNo;
    innermailListView.detailParams.mailType = innermailListView.initParams.mailType;
    innermailListView.detailParams.isCommon = 0;
    caac.guiframe.switchView("innermaildetail", innermailListView.detailParams, null, ".fj-content-container");
};


/**
 * 点击收件箱事件进入明细
 */
innermailListView.onInboxRowClicked = function (mailNo, isConfirmed) {

    innermailListView.detailParams.mailNo = mailNo;
    innermailListView.detailParams.isConfirmed = isConfirmed;
    innermailListView.detailParams.mailType = innermailListView.initParams.mailType;
    innermailListView.detailParams.isCommon = 0;
    caac.guiframe.switchView("innermaildetail", innermailListView.detailParams, null, ".fj-content-container");
};

/**
 * 改变展示的List
 */
innermailListView.onChangeList = function (mailType) {

    if (innermailListView.initParams.mailType != mailType) {
        innermailListView.initParams.mailType = mailType;
        innermailListView.initData();
    }
};

/**
 * 初始化事件
 */
innermailListView.initEvents = function () {

    // 如果左侧画面是弹出状态，点击任意地方左侧收回
    $(".fj-mail-panel").bind("click", function (event) {

        var className = $(".fj-mail-panel .fj-personal-panel").prop("class");

        if (className.indexOf("slideOutLeft") == -1) {
            $(".fj-mail-panel .fj-personal-panel").removeClass("slideInLeft").addClass("slideOutLeft");
        }
    });

    // 点击左侧画面弹出
    $(".fj-mail-panel #dv_show_person").bind("click", function (event) {

        var className = $(".fj-mail-panel .fj-personal-panel").prop("class");

        if (className.indexOf("slideInLeft") == -1) {
            $(".fj-mail-panel .fj-personal-panel").removeClass("fj-hidden").removeClass("slideOutLeft").addClass("slideInLeft");
        } else {
            $(".fj-mail-panel .fj-personal-panel").removeClass("slideInLeft").addClass("slideOutLeft");
        }

        event.stopPropagation();
    });

    // 绑定返回主页按钮
    $(".fj-mail-panel #dv_home").bind("click", function (event) {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    });

    // 新建信件
    $(".fj-mail-panel #dv_add").bind("click", function (event) {

        innermailListView.detailParams.mailType = 5;
        innermailListView.detailParams.isCommon = 0;
        caac.guiframe.switchView("innermaildetail", innermailListView.detailParams, null, ".fj-content-container");
    });
};
