// 获取视图信息
var loginView = caac.guiframe.getView("login");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化参数
    loginView.login = {};
    loginView.innermail = {};
    // 初始化控件
    loginView.initWidgets();
    // 初始化事件
    loginView.initEvents();
}

/**
 * 初始化控件
 */
loginView.initWidgets = function () {

    loginView.viewModel = kendo.observable({
        account: null,
        password: null
    });

    kendo.bind($(".fj-login-container"), loginView.viewModel);

    // 固定高度不随键盘变化
    var heightNum = $(".fj-login-container").height();
    $(".fj-login-container").height(heightNum);
};

/**
 * 初始化事件
 */
loginView.initEvents = function () {

    // 绑定点击登陆按钮
    $(".fj-login-container #btn_login").bind("click", function () {

        // 取得用户名
        loginView.login.account = loginView.viewModel.get("account");
        // 取得登录密码
        loginView.login.password = loginView.viewModel.get("password");

        loginView.login.deviceId = device.uuid;

        loginView.login.version = "version";

        if (caac.util.isBlank(loginView.login.account) || caac.util.isBlank(loginView.login.password)) {

            caac.guiframe.showMessage("帐号或密码不能为空", caac.constants.messageTypes.WARNING);
            return false;
        }

        // 发送请求
        caac.util.postSyncServerEvent(caac.constants.httpHead.URLHEAD + "login/login.act", loginView.login, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {

                    // 如果账号密码正确，设置localStorage为true
                    localStorage.setItem("loginStatus", 1);
                    localStorage.setItem("name", data.bean.name);
                    localStorage.setItem("departmentName", data.bean.departmentName);
                    localStorage.setItem("account", loginView.login.account);
                    localStorage.setItem("isLimit", data.bean.isLimit);
                    localStorage.setItem("isExecutive", data.isExecutive);

                    //  极光推送设置标签
                    window.JPush.setTags({ sequence: 1, tags: data.bean.tags});

                    caac.util.postSyncServerEvent(caac.constants.httpHead.URLHEAD + "msghints/getcount.act", null, function (result) {
                        caac.util.doReturnValue({
                            returnValue: result,
                            success: function (data) {

                                localStorage.setItem("msgCount", data.msgCount);
                                cordova.plugins.notification.badge.set(data.msgCount);

                            },
                            error: function (data) {

                            }
                        });
                    });

                    // 登陆成功跳转到首页
                    caac.guiframe.switchView("home", null, null, ".fj-content-container");
                },
                error: function (data) {

                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    });

    // 绑定点击返回按钮
    $(".fj-login-container #btn_return").bind("click", function () {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    });
};


