// 获取试图信息
var msghintsListView = caac.guiframe.getView("msghintslist");


/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    msghintsListView.initParams = {};
    msghintsListView.detailParams = {};

    // 初始化数据
    msghintsListView.initData();
    // 初始化事件
    msghintsListView.initEvents();

}


/**
 * 初始化数据
 */
msghintsListView.initData = function () {

    caac.guiframe.showScreenPanel();

    //  获取并更新当前的未读消息数量
    caac.util.postSyncServerEvent(caac.constants.httpHead.URLHEAD + "msghints/getcount.act", null, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                localStorage.setItem("msgCount", data.msgCount);
                cordova.plugins.notification.badge.set(data.msgCount);
            },
            error: function (data) {

            }
        });
    });

    msghintsListView.initParams.pageNum = 1;

    //发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "msghints/initdata.act", msghintsListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {

                    // 取得列表视图模板
                    var gridTemplate = kendo.template($(".fj-mail-panel #msg_grid_content").html());
                    // 设置列表视图内容
                    $(".fj-mail-panel .fj-container").html(gridTemplate(data.list));
                } else {

                    // 取得列表视图模板
                    var noGridTemplate = kendo.template($(".fj-mail-panel #dv_content_nodata").html());
                    $(".fj-mail-panel .fj-container").html(noGridTemplate);
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};


/**
 * 更多点击事件
 */
msghintsListView.onShowMoreClicked = function () {

    caac.guiframe.showScreenPanel();

    msghintsListView.initParams.pageNum = parseInt(msghintsListView.initParams.pageNum) + 1;

    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "msghints/initdata.act", msghintsListView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {

                    var msgGridTemplate = kendo.template($(".fj-mail-panel #msg_row_content").html());
                    // 循环处理需要增加的数据
                    for (var i = 0, len = data.list.length; i < len; i++) {
                        // 设置列表视图内容
                        $(".fj-mail-panel .fj-container .fj-mail-summary:nth-last-child(2)").after(msgGridTemplate(data.list[i]));
                    }
                    if (data.list.length < 10) {
                        // 设置显示更多按钮不可见
                        $(".fj-mail-panel .fj-show-more").addClass("fj-hidden");
                    }
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 点击收件箱事件进入明细
 */
msghintsListView.onRowClicked = function (target, targetType) {

    if (targetType == 3) {

        // 如果是站内信
        msghintsListView.detailParams.mailNo = target;
        msghintsListView.detailParams.isConfirmed = 0;
        msghintsListView.detailParams.mailType = 1;
        msghintsListView.detailParams.isCommon = 0;
        msghintsListView.detailParams.returnName = "msghintslist";
        caac.guiframe.switchView("innermaildetail", msghintsListView.detailParams, null, ".fj-content-container");
    } else if (targetType == 5) {

        // 如果是紧急事件
        msghintsListView.detailParams.emergencyNo = target;
        msghintsListView.detailParams.isConfirmed = 0;
        msghintsListView.detailParams.eventType = 1;
        msghintsListView.detailParams.returnName = "msghintslist";

        caac.guiframe.switchView("eventdetail", msghintsListView.detailParams, null, ".fj-content-container");
    }

};

/**
 * 初始化事件
 */
msghintsListView.initEvents = function () {

    // 绑定返回主页按钮
    $(".fj-mail-panel #dv_home").bind("click", function (event) {

        caac.guiframe.switchView("personal", null, null, ".fj-content-container");
    });
};
