// 获取视图信息
var personalView = caac.guiframe.getView("personal");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化控件
    personalView.initWidgets();
    // 初始化数据
    personalView.initData();
    // 初始化事件
    personalView.initEvents();
}

/**
 * 初始化控件
 */
personalView.initWidgets = function () {

    personalView.viewModel = kendo.observable({
        name: null,
        departmentName: null
    });

    kendo.bind($(".fj-personal-container"), personalView.viewModel);

    if (localStorage.getItem("msgCount") != 0) {

        document.getElementById("dv_notif_hint").className = "fj-notif-hint";
    }

    if(localStorage.getItem("versionUpdate") === "1") {

        document.getElementById("dv_version_hint").className = "fj-version-hint";
    }
};

/**
 * 初始化数据
 */
personalView.initData = function () {

    personalView.viewModel.set("name", localStorage.getItem("name"));
    personalView.viewModel.set("departmentName", localStorage.getItem("departmentName"));
};

/**
 * 初始化化事件
 */
personalView.initEvents = function () {

    // 绑定小铃铛
    $(".fj-personal-container #dv_msghints").bind("click", function (event) {

        if (localStorage.getItem("msgCount") != 0) {

            caac.guiframe.switchView("msghintslist", null, null, ".fj-content-container");
        } else {

            caac.guiframe.showMessage("暂时没有新的消息", caac.constants.messageTypes.WARNING);
        }
    });

    // 绑定首页按钮
    $(".fj-personal-container #dv_home").bind("click", function (event) {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    });

    // 绑定修改个人信息按钮
    $(".fj-personal-container #dv_personalform").bind("click", function (event) {

        caac.guiframe.switchView("personalform", null, null, ".fj-content-container");
    });

    // 绑定修改密码按钮
    $(".fj-personal-container #dv_updatepassword").bind("click", function (event) {

        caac.guiframe.switchView("updatepassword", null, null, ".fj-content-container");
    });

    // 绑定工作动态填报
    $(".fj-personal-container #dv_workdynamicsform").bind("click", function (event) {

        personalView.workdynamics = {};
        personalView.workdynamics.returnType = 1;
        caac.guiframe.switchView("workdynamicsform", personalView.workdynamics, null, ".fj-content-container");
    });

    // 绑定检查新版本
    $(".fj-personal-container #dv_checkversion").bind("click", function (event) {

        cordova.getAppVersion.getVersionNumber().then(function (version) {

            caac.util.postSyncServerEvent(caac.constants.httpHead.URLHEAD + "login/versioncheck.act", {version: version}, function (result) {
                caac.util.doReturnValue({
                    returnValue: result,
                    success: function (data) {

                        localStorage.setItem("versionUpdate", 0);

                        caac.guiframe.showMessage("您当前为最新版本", caac.constants.messageTypes.WARNING);
                    },
                    error: function (data) {

                        localStorage.setItem("versionUpdate", 1);

                        var message = "检查到新版本,是否现在下载？";
                        var title = "消息";
                        var buttonLabels = ["是" , "否"];

                        navigator.notification.confirm(message, function (buttonIndex) {

                            if (buttonIndex == 1) {

                                if (device.platform === "Android") {

                                    cordova.InAppBrowser.open("http://safety.caac.gov.cn/caac/software/safety.apk", '_system');
                                    navigator.app.exitApp();
                                } else if (device.platform === "iOS") {

                                    cordova.InAppBrowser.open("https://itunes.apple.com/cn/app/航安系统/id1439759945?mt=8", '_system');
                                    navigator.app.exitApp();
                                }
                            }
                        }, title, buttonLabels);
                    }
                });
            });

        });
    });

    // 绑定注销按钮
    $(".fj-personal-container #dv_logout").bind("click", function (event) {

        var message = "您确认要注销吗？";
        var title = "问题";
        var buttonLabels = "是,否";

        navigator.notification.confirm(message, function (buttonIndex) {

            if (buttonIndex == 1) {
                // 发送请求
                caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "login/logout.act", null, function (result) {
                    caac.util.doReturnValue({
                        returnValue: result,
                        success: function (data) {

                            localStorage.setItem("msgCount", 0);

                            // 删除登录状态跳入主页
                            localStorage.setItem("loginStatus", null);
                            localStorage.setItem("name", null);
                            localStorage.setItem("departmentName", null);
                            localStorage.setItem("account", null);

                            //  极光推送删除所有标签
                            window.JPush.cleanTags({sequence: 1});
                            //  清除角标
                            cordova.plugins.notification.badge.clear();

                            caac.guiframe.switchView("home", null, null, ".fj-content-container");
                        },
                        error: function (data) {

                            caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                        }
                    });
                });
            }
        }, title, buttonLabels);
    });
};
