var personalformView = caac.guiframe.getView("personalform");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化控件
    personalformView.initWidgets();
    // 初始化数据
    personalformView.initData();
    // 初始化事件
    personalformView.initEvents();
}

/**
 * 初始化控件
 */
personalformView.initWidgets = function () {

    personalformView.viewModel = kendo.observable({
        name: null,
        departmentName: null,
        phone: null,
        fax: null,
        mobilePhone: null,
        mail: null,
        address: null
    });

    kendo.bind($(".fj-personalform-container"), personalformView.viewModel);
};

/**
 * 初始化数据
 */
personalformView.initData = function () {

    // 发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "personnelform/initdata.act", null, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                personalformView.viewModel.set("name", data.name);
                personalformView.viewModel.set("departmentName", data.departmentName);
                personalformView.viewModel.set("phone", data.phone);
                personalformView.viewModel.set("fax", data.fax);
                personalformView.viewModel.set("mobilePhone", data.mobilePhone);
                personalformView.viewModel.set("mail", data.mail != null ? data.mail : "0@0");
                personalformView.viewModel.set("address", data.address);

            },
            error: function (data) {
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 初始化化事件
 */
personalformView.initEvents = function () {

    // 绑定确认按钮
    $(".fj-personalform-container #btn_ok").bind("click", function () {

        // 获取所需数据
        var personalBean = {
            name: personalformView.viewModel.get("name"),
            departmentName: personalformView.viewModel.get("departmentName"),
            phone: personalformView.viewModel.get("phone"),
            fax: personalformView.viewModel.get("fax"),
            mobilePhone: personalformView.viewModel.get("mobilePhone"),
            mail: personalformView.viewModel.get("mail"),
            address: $("#text_address").val()
        };

        // 发送请求获取各个控件的初始数据
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "personnelform/change.act", {args: JSON.stringify(personalBean)}, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {

                    // 返回个人信息页面
                    caac.guiframe.switchView("personal", null, null, ".fj-content-container");
                    caac.guiframe.showMessage("个人信息修改成功", caac.constants.messageTypes.SUCCESS);
                },
                error: function (data) {
                    caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
                }
            });
        });

    });

    // 绑定返回按钮
    $(".fj-personalform-container #dv_back_symbol").bind("click", function () {

        // 返回个人信息页面
        caac.guiframe.switchView("personal", null, null, ".fj-content-container");
    });
};