// 获取页面对象
var informationlistView = caac.guiframe.getView("informationlist");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    informationlistView.initParams = args;
    // 控件初始化
    informationlistView.initWidgets();
    // 数据初始化
    informationlistView.initData();
    // 事件初始化
    informationlistView.initEvents();
}

/**
 * 控件初始化
 */
informationlistView.initWidgets = function () {

    informationlistView.viewModel = kendo.observable({
        title: ""
    });

    kendo.bind($(".fj-news-container"), informationlistView.viewModel);
};

/**
 * 数据初始化
 */
informationlistView.initData = function () {

    if (informationlistView.initParams.newsType == 1) {

        // 设置标题
        informationlistView.viewModel.set("title", "新闻公告");

        // 取得列表视图模板
        var gridTemplate = kendo.template($(".fj-news-container #tmplt_new").html());
        // 设置列表视图内容
        $(".fj-news-container #dv_subject_items").html(gridTemplate);

    } else if (informationlistView.initParams.newsType == 2) {

        // 设置标题
        informationlistView.viewModel.set("title", "共享信息");

        // 取得列表视图模板
        var gridTemplate = null;
        var isExecutive = localStorage.getItem("isExecutive");

        if (isExecutive == 1) {

            gridTemplate = kendo.template($(".fj-news-container #tmplt_sharedinformation").html());
        } else {

            gridTemplate = kendo.template($(".fj-news-container #tmplt_sharedinformation2").html());
        }

        // 设置列表视图内容
        $(".fj-news-container #dv_subject_items").html(gridTemplate);

        // 左右换页控件
        $(".owl-carousel").owlCarousel({
            loop: true,
            items: 1
        });
    }

    // 设置最近访问
    if (informationlistView.initParams.newsType == 1) {

        var articleHistory = JSON.parse(localStorage.getItem("articleHistory"));

        if (articleHistory != null) {

            var historyTemplate = kendo.template($(".fj-news-container #tmplt_history").html());

            for (let i = articleHistory.length - 1; i >= 0; i--) {

                $(".fj-news-container #dv_history_list").append(historyTemplate(articleHistory[i]));
            }
        }
    } else {

        var informationHistory = JSON.parse(localStorage.getItem("informationHistory"));

        if (informationHistory != null) {

            var historyTemplate = kendo.template($(".fj-news-container #tmplt_history").html());

            for (let i = informationHistory.length - 1; i >= 0; i--) {

                $(".fj-news-container #dv_history_list").append(historyTemplate(informationHistory[i]));
            }
        }
    }
};

/**
 * 事件初始化
 */
informationlistView.initEvents = function () {

    // 绑定返回按钮
    $(".fj-news-container #dv_back_home").bind("click", function () {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    })
};

/**
 * 跳转到对应专题
 */
informationlistView.onClickArticleList = function (subjectNo, subjectTitle) {

    informationlistView.articleList = {};
    informationlistView.articleList.subjectNo = subjectNo;
    informationlistView.articleList.subjectTitle = subjectTitle;
    informationlistView.articleList.newsType = informationlistView.initParams.newsType;

    caac.guiframe.switchView("articlelist", informationlistView.articleList, null, ".fj-content-container");
};

/**
 * 跳转到对应文章
 */
informationlistView.onClickArticleDetail = function (articleNo, subjectTitle) {

    informationlistView.articleDetail = {};
    informationlistView.articleDetail.articleNo = articleNo;
    informationlistView.articleDetail.subjectTitle = subjectTitle;
    informationlistView.articleDetail.newsType = informationlistView.initParams.newsType;

    caac.guiframe.switchView("articledetail", informationlistView.articleDetail, null, ".fj-content-container");
};
