// 获取视图对象
var eventdetailView = caac.guiframe.getView("eventdetail");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    eventdetailView.initParams = args;

    // 初始化控件
    eventdetailView.initWidgets();
    // 初始化数据
    eventdetailView.initData();
    // 初始化事件
    eventdetailView.initEvents();
}

/**
 * 初始化控件
 */
eventdetailView.initWidgets = function () {

    eventdetailView.viewModel = kendo.observable({
        senderName : null,
        subject: null,
        content: null,
        attachmentsCount: null
    });

    kendo.bind($(".fj-eventdetail-container"), eventdetailView.viewModel);
};

/**
 * 初始化数据
 */
eventdetailView.initData = function () {

    caac.guiframe.showScreenPanel();

    // 发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "emergencydetail/initdata.act", eventdetailView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (eventdetailView.initParams.isConfirmed == 0) {

                    var msgCount = localStorage.getItem("msgCount");
                    localStorage.setItem("msgCount", msgCount - 1);
                    cordova.plugins.notification.badge.decrease(1);
                }

                eventdetailView.viewModel.set("senderName", data.bean.senderName);
                eventdetailView.viewModel.set("subject", data.bean.subject);
                eventdetailView.viewModel.set("content", data.bean.content);

                // 收件人
                var addresseeArr = [];
                var addresseeNameArr = data.bean.addresseeName.split("、");

                for (var index = 0; index < addresseeNameArr.length; index++) {

                    var addressee = {};
                    addressee.shortName = addresseeNameArr[index];
                    addresseeArr.push(addressee);
                }

                // 取得收件人模板对象
                var headerItemTemplate = kendo.template($(".fj-eventdetail-container #tmplt_addresseel_item").html());

                $(".fj-eventdetail-container .fj-contactors").html("");
                $.each(addresseeArr, function (n, value) {
                    // 将数据放入模板并显示在对应位置
                    $(".fj-eventdetail-container .fj-contactors").append(headerItemTemplate(value));
                });

                // 附件
                if (caac.util.isNotEmpty(data.fileList)) {

                    $(".fj-eventdetail-container .fj-event-attachments").removeClass("fj-hidden");

                    var size = 0;

                    // 取得附件列表控件模板
                    headerItemTemplate = kendo.template($(".fj-eventdetail-container #tmplt_attachment_item").html());

                    var tmpPathArr = [];
                    $.each(data.fileList, function (n, value) {
                        // 将新的页头添加到导航控件中
                        $(".fj-eventdetail-container .fj-attachment-list").append(headerItemTemplate(value));
                        tmpPathArr.push(value.filePath);

                        size += value.fileSize;
                    });

                    eventdetailView.viewModel.set("attachmentsCount" , "共 "+ data.fileList.length +" 个附件 " + "("+ Number(size/1048576).toFixed(2) +"MB)");
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {
                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 初始化事件
 */
eventdetailView.initEvents = function () {

    // 绑定返回按钮
    $(".fj-eventdetail-container #dv_back_list").bind("click", function() {

        if (eventdetailView.initParams.returnName == "msghintslist") {

            caac.guiframe.switchView("msghintslist", null, null, ".fj-content-container");
        } else {

            caac.guiframe.switchView("eventlist", eventdetailView.initParams, null, ".fj-content-container");
        }
    });

    // 控制附件隐藏和查看
    $(".fj-eventdetail-container #dv_show_attachment").bind("click", function (event) {

        var className = $(".fj-eventdetail-container .fj-attachment-list").prop("class");

        if (className.indexOf("fj-hidden") == -1) {

            document.getElementById("i_icon").className = "fa fa-chevron-up fa-2x";
            $(".fj-eventdetail-container .fj-attachment-list").addClass("fj-hidden");

        } else {

            document.getElementById("i_icon").className = "fa fa-chevron-down fa-2x";
            $(".fj-eventdetail-container .fj-attachment-list").removeClass("fj-hidden");
        }
    });


    // 绑定文件按钮
    $(".fj-eventdetail-container #dv-show-share").bind("click", function () {

        var change = document.getElementById("dv-share-list");

        if (change != undefined && change != null) {

            if (change.className.indexOf("fj-hidden") == -1) {
                change.className = "fj-hidden";
            } else {
                change.className = "";
            }
        }
    });
};

/**
 * 发送短信
 */
eventdetailView.shareMessage = function() {

    var message = "【" + eventdetailView.viewModel.get("subject") + "】\n\n" + eventdetailView.viewModel.get("content") + "\n\n------转发自【航安系统APP】";

    var options = {
        replaceLineBreaks: false,
        android: {
            intent: 'INTENT'
        }
    };

    var number = "";

    sms.send(number.toString(), message, options, null, null);
};


/**
 * 微信分享
 */
eventdetailView.shareWeChart = function() {

    Wechat.isInstalled(function (installed) {
        if (installed == "No") {

            caac.guiframe.showMessage("请先下载微信App。", caac.constants.messageTypes.WARNING);
            return false;
        } else {

            Wechat.share({
                text: "【" + eventdetailView.viewModel.get("subject") + "】\n\n" + eventdetailView.viewModel.get("content") + "\n\n------转发自【航安系统APP】",
                scene: Wechat.Scene.SESSION
            }, function () {

                caac.guiframe.showMessage("分享成功。", caac.constants.messageTypes.WARNING);
            }, function (reason) {

                caac.guiframe.showMessage("分享失败。", caac.constants.messageTypes.WARNING);
            });
        }
    }, function (reason) {

        caac.guiframe.showMessage("发生了一些错误。", caac.constants.messageTypes.WARNING);
        return false;
    });


};


/**
 * 下载附件
 */
eventdetailView.onViewAttachmentClicked = function onViewAttachmentClicked(checkSum, fileName) {

    cordova.InAppBrowser.open(encodeURI(encodeURI(caac.constants.httpHead.URLHEAD + "emergencydetail/download.act?checkSum=" + checkSum + "&fileName=" + fileName)),'_system');
};