// 获取视图对象
var eventformView = caac.guiframe.getView("eventform");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    eventformView.initParams = args;

    // 初始化控件
    eventformView.initWidgets();
    // 初始化数据
    eventformView.initData();
    // 初始化事件
    eventformView.initEvents();
}

/**
 * 初始化控件
 */
eventformView.initWidgets = function () {

    eventformView.viewModel = kendo.observable({
        addressee: null,
        addresseeStrArr: [],
        subject: null,
        content: null,
        attachmentsArr: [],
        attachmentsTmpPath: null,
        eventBean: {},
        attachmentsCount: 0,
        attachmentsSize: 0
    });

    kendo.bind($(".fj-eventform-container"), eventformView.viewModel);

    //拖拽功能
    // 初始化拖放对象
    $(".fj-eventform-container .fj-button-bar").kendoDraggable({
        hint: function (element) {

            // 返回拖放对象
            return element.clone().css("opacity", "0");
        },
        dragstart: function (event) {

        },
        dragend: function (event) {

            // 取得筛选条件对象
            var draggable = $(".fj-eventform-container .fj-button-bar").data("kendoDraggable");
            // 设置传输列表上方位置
            $(".fj-eventform-container .fj-button-bar").css("top", draggable.hintOffset.top);
            // 设置传输列表左方位置
            $(".fj-eventform-container .fj-button-bar").css("left", draggable.hintOffset.left);
        }
    });

    // 初始化拖放目标对象
    $("body").kendoDropTarget({
        dragenter: function (event) {
        },
        dragleave: function (event) {
        },
        drop: function (event) {
        }
    });
};

/**
 * 初始化数据
 */
eventformView.initData = function () {

    // 如果是选择单位页面返回，则加载之前保存的数据
    if (eventformView.initParams.isCommon == 1) {

        // 从共通页面返回
        var eventbean = eventformView.initParams.bean;
        eventformView.viewModel.set("addressee", eventbean.addressee);
        eventformView.viewModel.set("addresseeStrArr", eventbean.addresseeStrArr);
        eventformView.viewModel.set("subject", eventbean.subject);
        eventformView.viewModel.set("content", eventbean.content);
        eventformView.viewModel.set("attachmentsCount", eventbean.attachmentsCount);
        eventformView.viewModel.set("attachmentsSize", eventbean.attachmentsSize);

        // 取得主送人模板对象
        var headerItemTemplate = kendo.template($(".fj-eventform-container #tmplt_addresseel_item").html());

        $(".fj-eventform-container #dv_addresseel_item").html("");
        $.each(eventformView.viewModel.get("addresseeStrArr"), function (n, value) {
            // 将数据放入模板并显示在对应位置
            $(".fj-eventform-container #dv_addresseel_item").append(headerItemTemplate(value));
        });

        // 附件
        if (eventbean.attachmentList.length != 0) {

            $(".fj-eventform-container .fj-event-attachments").removeClass("fj-hidden");

            // 记录历史数据
            eventformView.viewModel.set("attachmentsArr", eventbean.attachmentList);

            // 取得附件列表控件模板
            headerItemTemplate = kendo.template($(".fj-eventform-container #tmplt_attachment_item").html());

            var tmpPathArr = [];
            $.each(eventbean.attachmentList, function (n, value) {

                $(".fj-eventform-container #dv-attachment-list").append(headerItemTemplate(value));
                tmpPathArr.push(value.filePath);
            });
            eventformView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));
        }
    }
};

/**
 * 初始化事件
 */
eventformView.initEvents = function () {

    // 绑定文件按钮
    $(".fj-eventform-container #dv-add-attachments").bind("click", function () {

        var change = document.getElementById("dv-attachments-list");

        if (change != undefined && change != null) {

            if (change.className.indexOf("fj-hidden") == -1) {
                change.className = "fj-hidden";
            } else {
                change.className = "";
            }
        }
    });

    $(".fj-eventform-container #dv_show_attachment").bind("click", function (event) {

        var className = $(".fj-eventform-container .fj-attachment-list").prop("class");

        if (className.indexOf("fj-hidden") == -1) {

            document.getElementById("i_icon").className = "fa fa-chevron-up fa-2x";
            $(".fj-eventform-container .fj-attachment-list").addClass("fj-hidden");
        } else {

            document.getElementById("i_icon").className = "fa fa-chevron-down fa-2x";
            $(".fj-eventform-container .fj-attachment-list").removeClass("fj-hidden");
        }
    });

    // 绑定返回按钮
    $(".fj-eventform-container #dv_back_home").bind("click", function () {

        eventformView.returnListPage();
    });

    // 绑定选择单位
    $(".fj-eventform-container #dv_add_contactor").bind("click", function () {

        eventformView.common = {};
        eventformView.common.commonType = 2;
        eventformView.common.viewName = "eventform";
        eventformView.common.backPage = eventformView.initParams.backPage;

        var eventBean = {
            addressee: eventformView.viewModel.get("addressee"),
            subject: eventformView.viewModel.get("subject"),
            content: $("#content").val(),
            attachmentList: eventformView.viewModel.get("attachmentsArr"),
            addresseeStrArr: eventformView.viewModel.get("addresseeStrArr"),
            attachmentsCount: eventformView.viewModel.get("attachmentsCount"),
            attachmentsSize: eventformView.viewModel.get("attachmentsSize")
        };

        eventformView.common.bean = eventBean;

        caac.guiframe.switchView("common", eventformView.common, null, ".fj-content-container");
    });

    // 绑定提交
    $(".fj-eventform-container #dv_send").bind("click", function () {

        eventformView.toSave();
    });
};

/**
 * 拍照事件
 */
eventformView.takePicture = function () {

    navigator.camera.getPicture(onSuccess, onFail, {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        encodingType: Camera.EncodingType.PNG,
        cameraDirection: 1
    });

    function onSuccess(imageURL) {

        eventformView.uploadFile(imageURL, caac.constants.httpHead.URLHEAD + "upload/upload.act");
    }

    function onFail(message) {
    }
};

/**
 * 获取手机照片事件
 */
eventformView.getPicture = function () {

    navigator.camera.getPicture(onSuccess, onFail, {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        mediaType: 2
    });

    function onSuccess(imageURL) {

        eventformView.uploadFile(imageURL, caac.constants.httpHead.URLHEAD + "upload/upload.act");
    }

    function onFail(message) {
    }
};


/**
 * 请求服务器保存数据
 */
eventformView.toSave = function () {

    // 设置form参数
    var emergency = {
        addressee: eventformView.viewModel.get("addressee"),
        subject: $(".fj-eventform-container #subject").val(),
        content: $(".fj-eventform-container #content").val(),
        attachmentsTmpPath: eventformView.viewModel.get("attachmentsTmpPath"),
        attachmentList: eventformView.viewModel.get("attachmentsArr")
    };

    //校验数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "emergencydetail/check.act", {eventData: JSON.stringify(emergency)}, function (data) {

        caac.util.doReturnValue({
            returnValue: data,
            success: function (result) {
                //保存数据
                caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "emergencydetail/save.act", {eventData: JSON.stringify(emergency)}, function (data) {

                    caac.util.doReturnValue({
                        returnValue: data,
                        success: function (result) {

                            caac.guiframe.showMessage("紧急事件发送成功", caac.constants.messageTypes.SUCCESS);
                            eventformView.returnListPage();
                        },
                        error: function (result) {

                            caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
                        }
                    });

                });
            },
            error: function (result) {
                caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
            }
        });

    });
};

/**
 * 上传文件
 */
eventformView.uploadFile = function (fileURL, uri) {

    var fileURL = fileURL;
    var uri = encodeURI(uri);
    var options = new FileUploadOptions();

    options.fileKey = "file";
    options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
    options.mimeType = fileURL.substr(fileURL.lastIndexOf('.') + 1);

    var headers = {'headerParam': 'headerValue'};
    options.headers = headers;

    var ft = new FileTransfer();

    ft.upload(fileURL, uri, onSuccess, onError, options);

    function onSuccess(r) {

        if ($(".fj-eventform-container .fj-event-attachments").hasClass("fj-hidden")) {

            $(".fj-eventform-container .fj-event-attachments").removeClass("fj-hidden");
        }

        var data = JSON.parse(r.response).data;
        var attaArr = eventformView.viewModel.get("attachmentsArr");
        var tmpArr = [];

        //获取新增的附件
        $.each(data, function (n, value) {

            //否则判断是否选中了相同的文件，如果有，则去重
            $.each(attaArr, function (m, historyAtta) {
                if (historyAtta.checkSum == value.checkSum && historyAtta.fileName == value.fileName) {
                    attaArr.splice(m, 1);
                    return false;
                }
            });
            tmpArr.push(value);
        });

        //记录所选附件信息
        $.each(tmpArr, function (n, value) {
            attaArr.push(value);
        });

        eventformView.viewModel.set("attachmentsCount", attaArr.length);
        eventformView.viewModel.set("attachmentsArr", attaArr);

        // 组织所选附件路径
        var tmpPathArr = [];
        var size = 0;
        $.each(attaArr, function (n, value) {
            tmpPathArr.push(value.filePath);
            size += value.fileSize;
        });

        eventformView.viewModel.set("attachmentsSize", Number(size / 1048576).toFixed(2));
        eventformView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));

        // 取得附件列表控件模板
        var headerItemTemplate = kendo.template($(".fj-eventform-container #tmplt_attachment_item").html());

        $(".fj-eventform-container #dv-attachment-list").html("");
        $.each(attaArr, function (n, value) {
            // 将新的页头添加到导航控件中
            $(".fj-eventform-container #dv-attachment-list").append(headerItemTemplate(value));
        });
    }

    function onError(error) {

    }
};

/**
 * 删除所选收件人
 */
eventformView.onRemoveAddresseeClicked = function (event) {

    // 获取选中项
    var selecedItem = $(event.target.parentElement);
    // 改变所选主送人结果
    var addresseeStrArr = eventformView.viewModel.get("addresseeStrArr");
    var addresseeArr = [];

    // 将所选数据从数据源中删除
    for (var i = addresseeStrArr.length - 1; i >= 0; i--) {
        if (addresseeStrArr[i].no == selecedItem.prop("id")) {
            addresseeStrArr.splice(i, 1);
        } else {
            addresseeArr.push(addresseeStrArr[i].no);
        }
    }

    eventformView.viewModel.set("addresseeStrArr", addresseeStrArr);
    eventformView.viewModel.set("addressee", addresseeArr.join(","));

    // 从页面上删除选中项
    selecedItem.remove();
    // 阻止事件冒泡
    event.stopPropagation();

};

eventformView.returnListPage = function () {

    eventformView.unsafeevent = {};
    eventformView.unsafeevent.eventType = 1;
    caac.guiframe.switchView(eventformView.initParams.backPage, eventformView.unsafeevent, null, ".fj-content-container");
};


/**
 * 删除所选附件
 */
eventformView.onRemoveAttachmentsClicked = function (event, fileSize) {

    var selecedItem = $(event.target.parentElement.parentElement);

    // 改变所选附件结果
    var attaArr = eventformView.viewModel.get("attachmentsArr");
    // 将所选数据从数据源中删除
    for (var i = attaArr.length - 1; i >= 0; i--) {
        if (attaArr[i].checkSum == selecedItem.prop("id") || attaArr[i].fileName == $(event.target).html()) {
            attaArr.splice(i, 1);
            break;
        }
    }
    eventformView.viewModel.set("attachmentsArr", attaArr);

    // 重新组织所选附件路径
    var tmpPathArr = [];
    $.each(attaArr, function (n, value) {
        tmpPathArr.push(value.filePath);
    });
    eventformView.viewModel.set("attachmentsTmpPath", tmpPathArr.join(","));

    // 从页面上删除选中项
    selecedItem.remove();

    eventformView.viewModel.set("attachmentsSize", eventformView.viewModel.get("attachmentsSize") - fileSize);
    eventformView.viewModel.set("attachmentsCount", eventformView.viewModel.get("attachmentsCount") - 1);

    if (eventformView.viewModel.get("attachmentsCount") == 0) {

        $(".fj-eventform-container .fj-event-attachments").addClass("fj-hidden");
    }

    // 阻止事件冒泡
    event.stopPropagation();
};