// 获取页面对象
var eventlistView = caac.guiframe.getView("eventlist");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    eventlistView.initParams = args;

    // 初始化控件
    eventlistView.initWidgets();
    // 初始化数据
    eventlistView.initData();
    // 初始化事件
    eventlistView.initEvents();
}

/**
 * 初始化控件
 */
eventlistView.initWidgets = function () {

};

/**
 * 初始化数据
 */
eventlistView.initData = function () {

    caac.guiframe.showScreenPanel();

    eventlistView.initParams.pageNum = 1;

    // 改变样式
    var inboxInfoPanel = document.getElementById("dv-inbox");
    var outboxInfoPanel = document.getElementById("dv-outbox");

    if (eventlistView.initParams.eventType == 1) {
        inboxInfoPanel.className = "fj-event-selected";
        outboxInfoPanel.className = "";

        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "msghints/getcount.act", null, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {

                    localStorage.setItem("msgCount", data.msgCount);
                    cordova.plugins.notification.badge.set(data.msgCount);
                },
                error: function (data) {

                }
            });
        });

    } else if (eventlistView.initParams.eventType == 2) {
        inboxInfoPanel.className = "";
        outboxInfoPanel.className = "fj-event-selected";
    }

    //发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "emergencylist/initdata.act", eventlistView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {


                    // 取得列表视图模板
                    var gridTemplate = kendo.template($(".fj-event-panel #tmplt_grid_content").html());
                    // 设置列表视图内容
                    $(".fj-event-panel .fj-event-container").html(gridTemplate(data.list));

                } else {

                    // 取得列表视图模板
                    var noGridTemplate = kendo.template($(".fj-event-panel #dv_content_nodata").html());
                    // 设置列表视图内容
                    $(".fj-event-panel .fj-event-container").html(noGridTemplate);
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
            }
        });
    });
};


/**
 * 初始化事件
 */
eventlistView.initEvents = function () {

    // 绑定返回按钮
    $(".fj-event-panel #dv_back_home").bind("click", function () {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    });

    // 新建紧急事件
    $(".fj-event-panel .fj-add-button").bind("click", function () {

        eventlistView.event = {};
        eventlistView.event.backPage = "eventlist";
        eventlistView.event.isCommon = 0;
        caac.guiframe.switchView("eventform", eventlistView.event, null, ".fj-content-container");
    });
};

/**
 * 点击查看更多
 */
eventlistView.onShowMoreClicked = function () {

    caac.guiframe.showScreenPanel();

    eventlistView.initParams.pageNum = parseInt(eventlistView.initParams.pageNum) + 1;

    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "emergencylist/initdata.act", eventlistView.initParams, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                if (caac.util.isNotEmpty(data.list)) {

                    var gridTemplate = kendo.template($(".fj-event-panel #tmplt_row_content").html());

                    // 循环处理需要增加的数据
                    for (var i = 0, len = data.list.length; i < len; i++) {
                        // 设置列表视图内容
                        $(".fj-event-panel .fj-event-container .fj-event-item:nth-last-child(2)").after(gridTemplate(data.list[i]));
                    }

                    if (data.list.length < 10) {

                        // 设置显示更多按钮不可见
                        $(".fj-event-panel .fj-show-more").addClass("fj-hidden");
                    }
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 点击事件进入明细
 */
eventlistView.onRowClicked = function (emergencyNo, isConfirmed) {

    eventlistView.detailParams = {};
    eventlistView.detailParams.emergencyNo = emergencyNo;
    eventlistView.detailParams.isConfirmed = isConfirmed;
    eventlistView.detailParams.eventType = eventlistView.initParams.eventType;

    caac.guiframe.switchView("eventdetail", eventlistView.detailParams, null, ".fj-content-container");
};

/**
 * 改变展示的List
 */
eventlistView.onClickBox = function (eventType) {

    if (eventType != eventlistView.initParams.eventType) {

        eventlistView.initParams.eventType = eventType;
        eventlistView.initData();
    }
};
