var upadatepasswordView = caac.guiframe.getView("upadatepassword");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化控件
    upadatepasswordView.initWidgets();
    // 初始化数据
    upadatepasswordView.initData();
    // 初始化事件
    upadatepasswordView.initEvents();
}

/**
 * 初始化控件
 */
upadatepasswordView.initWidgets = function () {

    upadatepasswordView.viewModel = kendo.observable({
        account: null,
        password: null,
        newPassword: null,
        confirmPassword: null
    });

    kendo.bind($(".fj-upadatepassword-container"), upadatepasswordView.viewModel);
};

/**
 * 初始化数据
 */
upadatepasswordView.initData = function () {

    // 发送请求获取各个控件的初始数据
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "upadatepassword/initdata.act", null, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                upadatepasswordView.viewModel.set("account", data.account);
            },
            error: function (data) {
                caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
            }
        });
    });

};

/**
 * 初始化化事件
 */
upadatepasswordView.initEvents = function () {

    // 绑定确认按钮
    $(".fj-upadatepassword-container #btn_ok").bind("click", function () {

        // 获取参数
        var newPassword = upadatepasswordView.viewModel.get("newPassword");
        var confirmPassword = upadatepasswordView.viewModel.get("confirmPassword");
        var password = upadatepasswordView.viewModel.get("password");

        if (caac.util.isBlank(password)) {

            caac.guiframe.showMessage("旧密码不能为空",caac.constants.messageTypes.WARNING);

            return false;
        }

        if (caac.util.isBlank(newPassword)) {

            caac.guiframe.showMessage("新密码不能为空",caac.constants.messageTypes.WARNING);

            return false;
        }

        if (caac.util.isBlank(confirmPassword)) {

            caac.guiframe.showMessage("确认新密码不能为空",caac.constants.messageTypes.WARNING);

            return false;
        }

        // 判断两次填写新密码是否一致
        if (newPassword != confirmPassword) {

            caac.guiframe.showMessage("确认密码有误，请重新输入",caac.constants.messageTypes.WARNING);
        } else {

            // 如果一致请求后台修改密码
            var personalBean = {
                account: upadatepasswordView.viewModel.get("account"),
                password: password,
                newPassword: newPassword,
                confirmPassword: confirmPassword
            };

            // 发送请求获取各个控件的初始数据
            caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "upadatepassword/update.act", {args: JSON.stringify(personalBean)}, function (result) {
                caac.util.doReturnValue({
                    returnValue: result,
                    success: function (data) {

                        // 返回个人信息页面
                        caac.guiframe.switchView("personal", null, null, ".fj-content-container");
                        caac.guiframe.showMessage("密码修改成功", caac.constants.messageTypes.SUCCESS);
                    },
                    error: function (data) {
                        caac.guiframe.showMessage(result.message,caac.constants.messageTypes.WARNING);
                    }
                });
            });
        }
    });

    // 绑定返回按钮
    $(".fj-upadatepassword-container #dv_back_symbol").bind("click", function () {

        // 返回个人信息页面
        caac.guiframe.switchView("personal", null, null, ".fj-content-container");
    });
};