// 获取视图信息
var workdynamicsView = caac.guiframe.getView("workdynamics");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    // 初始化控件
    workdynamicsView.initWidgets();
    // 初始化数据
    workdynamicsView.initData();
    // 初始化事件
    workdynamicsView.initEvents();
}

/**
 * 初始化控件
 */
workdynamicsView.initWidgets = function () {

    workdynamicsView.viewModel = kendo.observable({
        showMonthStr: null,
        showMonth: null,
        clickDateStr: null,
        clickDate: null,
        departmentArr: [],
        userArr: [],
        historyScheduler: [],
        futureScheduler: [],
        weekDateShow: null,
        loginUser: null,
        selectedDp: null,
        selectedUser: null,
        weekStartDate: null
    });

    kendo.bind($(".fj-calendar-container"), workdynamicsView.viewModel);

    // 初始化拖放对象
    $(".fj-calendar-container .fj-button-bar").kendoDraggable({
        hint: function (element) {

            // 返回拖放对象
            return element.clone().css("opacity", "0");
        },
        dragstart: function (event) {

        },
        dragend: function (event) {

            // 取得筛选条件对象
            var draggable = $(".fj-calendar-container .fj-button-bar").data("kendoDraggable");
            // 设置传输列表上方位置
            $(".fj-calendar-container .fj-button-bar").css("top", draggable.hintOffset.top);
            // 设置传输列表左方位置
            $(".fj-calendar-container .fj-button-bar").css("left", draggable.hintOffset.left);
        }
    });

    // 初始化拖放目标对象
    $("body").kendoDropTarget({
        dragenter: function (event) {
        },
        dragleave: function (event) {
        },
        drop: function (event) {
        }
    });
};

/**
 * 初始化数据
 */
workdynamicsView.initData = function () {

    caac.guiframe.showScreenPanel();

    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerdetail/initdata.act", null, function (result) {
        caac.util.doReturnValue({
            returnValue: result,
            success: function (data) {

                // 整理有事件的日期
                var DateArr = [];

                if (caac.util.isNotEmpty(data.list)) {

                    for (var i = 0, len = data.list.length; i < len; i++) {

                        DateArr = DateArr.concat(caac.util.getAllDate(data.list[i].startDate, data.list[i].endDate));
                    }
                }

                // 绑定日历事件
                caac.widgets.calendar.init(".fj-calendar-container .fj-month-view .fj-calendar-panel table", DateArr, function (date, hasSchedule) {

                    // 改变事件上面的日期
                    workdynamicsView.viewModel.set("clickDateStr", date.getFullYear() + "年" + (date.getMonth() + 1) + "月" + date.getDate() + "日");
                    workdynamicsView.viewModel.set("clickDate", date);

                    // 如果点击的日期有事件
                    if (hasSchedule) {

                        var item = {
                            startDate: date
                        };

                        // 查询数据库
                        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerdetail/findeventbyuseranddate.act", {args: JSON.stringify(item)}, function (result) {
                            caac.util.doReturnValue({
                                returnValue: result,
                                success: function (data) {

                                    if (caac.util.isNotEmpty(data)) {

                                        var eventTemplate = kendo.template($(".fj-calendar-container #tmplt_event_content").html());

                                        $(".fj-calendar-container .fj-event-list").html(eventTemplate(data));
                                    }

                                },
                                error: function (data) {
                                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                                }
                            });
                        });

                    } else {

                        // 设置事件显示为空
                        var eventTemplate = kendo.template($(".fj-calendar-container #tmplt_event_none").html());
                        $(".fj-calendar-container .fj-event-list").html(eventTemplate);
                    }
                });

                // 模拟点击一下当天日期
                $(".fj-calendar-container .fj-today").click();

                var date = new Date();

                // 查看当前日期的事件

                // 设置当前展示日历的年月
                workdynamicsView.viewModel.set("showMonth", date);
                workdynamicsView.viewModel.set("showMonthStr", date.getFullYear() + "年" + (date.getMonth() + 1) + "月");
                workdynamicsView.viewModel.set("clickDate", date);
                workdynamicsView.viewModel.set("clickDateStr", date.getFullYear() + "年" + (date.getMonth() + 1) + "月" + date.getDate() + "日");

                workdynamicsView.viewModel.set("loginUser", data.loginUser);

                // 设置当前选中的部门
                workdynamicsView.viewModel.set("selectedDp", data.loginUser.departmentNo);

                // 设置部门
                if (caac.util.isNotEmpty(data.departmentList)) {

                    workdynamicsView.viewModel.set("departmentArr", data.departmentList);

                    var departmentTemplate = kendo.template($(".fj-calendar-container #tmplt_department_content").html());
                    $(".fj-calendar-container .fj-department-list").html(departmentTemplate(data.departmentList));

                    $(".fj-calendar-container #" + data.loginUser.departmentNo).addClass("fj-selected");
                }

                // 设置人员
                if (caac.util.isNotEmpty(data.userList)) {

                    workdynamicsView.viewModel.set("userArr", data.userList);

                    var showUserArr = [];

                    showUserArr.push(data.userList[0]);

                    for (var i = 1, len = data.userList.length; i < len; i++) {

                        if (data.userList[i].departmentNo == data.loginUser.departmentNo) {

                            showUserArr.push(data.userList[i]);
                        }
                    }

                    // 设置显示的人员
                    var userTemplate = kendo.template($(".fj-calendar-container #tmplt_user_content").html());
                    $(".fj-calendar-container .fj-user-list").html(userTemplate(showUserArr));

                    $(".fj-calendar-container #allUserNo").addClass("fj-selected");
                }

                // 设置历史工作动态
                if (caac.util.isNotEmpty(data.historySchedulerList)) {

                    workdynamicsView.viewModel.set("historyScheduler", data.historySchedulerList);
                }

                // 设置往后工作动态
                if (caac.util.isNotEmpty(data.futureSchedulerList)) {

                    workdynamicsView.viewModel.set("futureScheduler", data.futureSchedulerList);
                }

                caac.guiframe.hideScreenPanel();
            },
            error: function (data) {

                caac.guiframe.hideScreenPanel();
                caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
            }
        });
    });
};

/**
 * 初始化事件
 */
workdynamicsView.initEvents = function () {

    // 点击返回按钮
    $(".fj-calendar-container #dv_workdynamics_return").bind("click", function (event) {

        caac.guiframe.switchView("home", null, null, ".fj-content-container");
    });

    // 点击个人
    $(".fj-calendar-container .fj-button-bar #dv_month_view").bind("click", function (event) {

        $(".fj-calendar-container .fj-month-view").removeClass("fj-hidden");
        $(".fj-calendar-container .fj-schedule-view").addClass("fj-hidden");

        $(".fj-calendar-container .fj-button-bar > div").removeClass("fj-selected");
        $(event.currentTarget).addClass("fj-selected");

        $(".fj-calendar-container .fj-schedule-view .fj-user-list").addClass("fj-hidden");
        $(".fj-calendar-container .fj-schedule-view .fj-department-list").addClass("fj-hidden");
    });

    // 点击查询
    $(".fj-calendar-container .fj-button-bar #dv_schedule_view").bind("click", function (event) {

        var scheduleView = $(".fj-calendar-container .fj-schedule-view");

        // 如果当前页面不为查询页面
        if (scheduleView.hasClass("fj-hidden")) {

            $(".fj-calendar-container .fj-month-view").addClass("fj-hidden");
            $(".fj-calendar-container .fj-schedule-view").removeClass("fj-hidden");

            $(".fj-calendar-container .fj-button-bar > div").removeClass("fj-selected");
            $(event.currentTarget).addClass("fj-selected");

            // 获取当前选中的日期
            var clickDate = workdynamicsView.viewModel.get("clickDate");
            // 获取当前选中的星期
            var week = clickDate.getDay();

            // 本星期起始时间
            var weekStartDate = new Date(clickDate.getFullYear(), clickDate.getMonth(), clickDate.getDate() - week);
            // 本星期结束时间
            var weekEndDate = new Date(weekStartDate.getFullYear(), weekStartDate.getMonth(), weekStartDate.getDate() + 6);

            // 保存当前星期起始时间
            workdynamicsView.viewModel.set("weekStartDate", weekStartDate);

            // 设置星期展示
            workdynamicsView.viewModel.set("weekDateShow", weekStartDate.getFullYear() + "年" + (weekStartDate.getMonth() + 1) + "月" + weekStartDate.getDate() + "日" + " - " + weekEndDate.getFullYear() + "年" + (weekEndDate.getMonth() + 1) + "月" + weekEndDate.getDate() + "日");

            var nowDateTime = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate()).getTime();

            var historySchedulerArr = workdynamicsView.viewModel.get("historyScheduler");
            var futureSchedulerArr = workdynamicsView.viewModel.get("futureScheduler");

            var loopNumber = 0;
            var loginUser = workdynamicsView.viewModel.get("loginUser");

            // 设置选中的人员
            workdynamicsView.viewModel.set("selectedUser", "allUserNo");

            // 组织数据
            for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

                var tempArr = [];

                if (k < nowDateTime) {

                    if (caac.util.isNotEmpty(historySchedulerArr)) {

                        for (var i = 0; i < historySchedulerArr.length; i++) {

                            if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].deptNo == loginUser.departmentNo) {
                                tempArr.push(historySchedulerArr[i]);
                            }

                            if (historySchedulerArr[i].endDate < k) {
                                break;
                            }
                        }
                    }

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == loginUser.departmentNo) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }
                } else {

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == loginUser.departmentNo) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }

                }

                // 组织数据
                var tempData = {};
                tempData.dateStr = new Date(k).getDate();
                tempData.list = tempArr;

                if (loopNumber == 0) {
                    var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
                    $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
                } else if (loopNumber == 1) {
                    var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
                    $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
                } else if (loopNumber == 2) {
                    var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
                    $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
                } else if (loopNumber == 3) {
                    var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
                    $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
                } else if (loopNumber == 4) {
                    var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
                    $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
                } else if (loopNumber == 5) {
                    var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
                    $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
                } else if (loopNumber == 6) {
                    var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
                    $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
                }

                k = k + 24 * 60 * 60 * 1000;
                loopNumber++;
            }
        } else {

        }
    });

    // 点击任意地方收回
    $(".fj-task-list").bind("click", function (event) {

        var className = $(".fj-calendar-container .fj-schedule-view .fj-user-list").prop("class");
        var className2 = $(".fj-calendar-container .fj-schedule-view .fj-department-list").prop("class");

        if (className.indexOf("fj-hidden") == -1) {
            $(".fj-calendar-container .fj-schedule-view .fj-user-list").addClass("fj-hidden");
        }

        if (className2.indexOf("fj-hidden") == -1) {
            $(".fj-calendar-container .fj-schedule-view .fj-department-list").addClass("fj-hidden");
        }
    });

    // 点击部门
    $(".fj-calendar-container .fj-schedule-view .fj-view-bar #dv_department_list").bind("click", function (event) {

        var departmentList = $(".fj-calendar-container .fj-schedule-view .fj-department-list");
        departmentList.hasClass("fj-hidden") ? departmentList.removeClass("fj-hidden") : departmentList.addClass("fj-hidden");

        $(".fj-calendar-container .fj-schedule-view .fj-user-list").addClass("fj-hidden");
    });

    // 点击人员
    $(".fj-calendar-container .fj-schedule-view .fj-view-bar #dv_user_list").bind("click", function (event) {

        var userList = $(".fj-calendar-container .fj-schedule-view .fj-user-list");
        userList.hasClass("fj-hidden") ? userList.removeClass("fj-hidden") : userList.addClass("fj-hidden");

        $(".fj-calendar-container .fj-schedule-view .fj-department-list").addClass("fj-hidden");
    });

    // 点击上一月

    $(".fj-calendar-container #dv-month-left").bind("click", function (event) {

        var showMonth = workdynamicsView.viewModel.get("showMonth");
        var newShowMonth = new Date(showMonth.getFullYear(), showMonth.getMonth() - 1);
        caac.widgets.calendar.render(newShowMonth);

        workdynamicsView.viewModel.set("showMonth", newShowMonth);
        workdynamicsView.viewModel.set("showMonthStr", newShowMonth.getFullYear() + "年" + (newShowMonth.getMonth() + 1) + "月");

        if (newShowMonth.getTime() == new Date(new Date().getFullYear(), new Date().getMonth()).getTime()) {

            // 如果是当前月，模拟点击当天
            $(".fj-calendar-container .fj-today").click();
        } else {

            // 如果不是当前月，模拟点击第一天
            $(".fj-calendar-container .fj-first-date").click();
        }
    });

    // 点击下一月
    $(".fj-calendar-container #dv-month-right").bind("click", function (event) {

        var showMonth = workdynamicsView.viewModel.get("showMonth");
        var newShowMonth = new Date(showMonth.getFullYear(), showMonth.getMonth() + 1);
        caac.widgets.calendar.render(newShowMonth);

        workdynamicsView.viewModel.set("showMonth", newShowMonth);
        workdynamicsView.viewModel.set("showMonthStr", newShowMonth.getFullYear() + "年" + (newShowMonth.getMonth() + 1) + "月");

        if (newShowMonth.getTime() == new Date(new Date().getFullYear(), new Date().getMonth()).getTime()) {

            // 如果是当前月，模拟点击当天
            $(".fj-calendar-container .fj-today").click();
        } else {

            // 如果不是当前月，模拟点击第一天
            $(".fj-calendar-container .fj-first-date").click();
        }
    });

    // 点击新建工作动态
    $(".fj-calendar-container #dv_create_event").bind("click", function (event) {

        workdynamicsView.workdynamics = {};
        workdynamicsView.workdynamics.returnType = 2;
        caac.guiframe.switchView("workdynamicsform", workdynamicsView.workdynamics, null, ".fj-content-container");
    });

    // 左右滑动日历
    var box = document.getElementById("dv_calendar_panel");
    var boxWidth = box.offsetWidth;

    // 初始化手指坐标点
    var startPoint = 0;
    var endPoint = 0;

    // 手指按下
    box.addEventListener("touchstart", function (e) {

        startPoint = e.changedTouches[0].pageX;
    });
    
    box.addEventListener("touchmove", function (e) {

        if (endPoint > startPoint) {


        } else if (endPoint < startPoint){

        }
    })

    // 手指抬起
    box.addEventListener("touchend", function (e) {

        endPoint = e.changedTouches[0].pageX;

        if (endPoint > startPoint && endPoint - startPoint > boxWidth / 4) {

            // 如果往右边滑动且滑动大于4分之一
            var showMonth = workdynamicsView.viewModel.get("showMonth");
            var newShowMonth = new Date(showMonth.getFullYear(), showMonth.getMonth() - 1);
            caac.widgets.calendar.render(newShowMonth);

            workdynamicsView.viewModel.set("showMonth", newShowMonth);
            workdynamicsView.viewModel.set("showMonthStr", newShowMonth.getFullYear() + "年" + (newShowMonth.getMonth() + 1) + "月");

            if (newShowMonth.getTime() == new Date(new Date().getFullYear(), new Date().getMonth()).getTime()) {

                // 如果是当前月，模拟点击当天
                $(".fj-calendar-container .fj-today").click();
            } else {

                // 如果不是当前月，模拟点击第一天
                $(".fj-calendar-container .fj-first-date").click();
            }

        } else if (endPoint < startPoint && startPoint - endPoint > boxWidth / 4) {

            // 如果往左边边滑动且滑动大于4分之一
            var showMonth = workdynamicsView.viewModel.get("showMonth");
            var newShowMonth = new Date(showMonth.getFullYear(), showMonth.getMonth() + 1);
            caac.widgets.calendar.render(newShowMonth);

            workdynamicsView.viewModel.set("showMonth", newShowMonth);
            workdynamicsView.viewModel.set("showMonthStr", newShowMonth.getFullYear() + "年" + (newShowMonth.getMonth() + 1) + "月");

            if (newShowMonth.getTime() == new Date(new Date().getFullYear(), new Date().getMonth()).getTime()) {

                // 如果是当前月，模拟点击当天
                $(".fj-calendar-container .fj-today").click();
            } else {

                // 如果不是当前月，模拟点击第一天
                $(".fj-calendar-container .fj-first-date").click();
            }
        }
    });

    // 左右滑动周日历
    var box2 = document.getElementById("dv-task-contents");

    // 初始化手指坐标点
    var startPoint2 = 0;
    var endPoint2 = 0;

    // 手指按下
    box2.addEventListener("touchstart", function (e) {

        startPoint2 = e.changedTouches[0].pageX;
    });

    // 手指抬起
    box2.addEventListener("touchend", function (e) {

        endPoint2 = e.changedTouches[0].pageX;

        var weekStartDate = null;
        var weekEndDate = null;

        if (endPoint2 > startPoint2 && endPoint2 - startPoint2 > boxWidth / 4) {

            // 如果往右边滑动且滑动大于4分之一
            var oldWeekStartDate = workdynamicsView.viewModel.get("weekStartDate");

            weekStartDate = new Date(oldWeekStartDate.getFullYear(), oldWeekStartDate.getMonth(), oldWeekStartDate.getDate() - 7);

            workdynamicsView.viewModel.set("weekStartDate", weekStartDate);

            // 本星期结束时间
            weekEndDate = new Date(weekStartDate.getFullYear(), weekStartDate.getMonth(), weekStartDate.getDate() + 6);


        } else if (endPoint2 < startPoint2 && startPoint2 - endPoint2 > boxWidth / 4) {

            // 如果往左边边滑动且滑动大于4分之一
            var oldWeekStartDate = workdynamicsView.viewModel.get("weekStartDate");

            weekStartDate = new Date(oldWeekStartDate.getFullYear(), oldWeekStartDate.getMonth(), oldWeekStartDate.getDate() + 7);

            workdynamicsView.viewModel.set("weekStartDate", weekStartDate);
            // 本星期结束时间
            weekEndDate = new Date(weekStartDate.getFullYear(), weekStartDate.getMonth(), weekStartDate.getDate() + 6);
        } else {

            return false;
        }

        // 设置星期展示
        workdynamicsView.viewModel.set("weekDateShow", weekStartDate.getFullYear() + "年" + (weekStartDate.getMonth() + 1) + "月" + weekStartDate.getDate() + "日" + " - " + weekEndDate.getFullYear() + "年" + (weekEndDate.getMonth() + 1) + "月" + weekEndDate.getDate() + "日");

        var nowDateTime = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate()).getTime();

        var historySchedulerArr = workdynamicsView.viewModel.get("historyScheduler");
        var futureSchedulerArr = workdynamicsView.viewModel.get("futureScheduler");

        // 获取选中的部门和用户
        var selectedDp = workdynamicsView.viewModel.get("selectedDp");
        var selectedUser = workdynamicsView.viewModel.get("selectedUser");

        var loopNumber = 0;
        // 组织数据
        if (selectedUser == "allUserNo") {

            // 组织数据
            for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

                var tempArr = [];

                if (k < nowDateTime) {

                    if (caac.util.isNotEmpty(historySchedulerArr)) {

                        for (var i = 0; i < historySchedulerArr.length; i++) {

                            if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].deptNo == selectedDp) {
                                tempArr.push(historySchedulerArr[i]);
                            }

                            if (historySchedulerArr[i].endDate < k) {
                                break;
                            }
                        }
                    }

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == selectedDp) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }
                } else {

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == selectedDp) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }
                }

                // 组织数据
                var tempData = {};
                tempData.dateStr = new Date(k).getDate();
                tempData.list = tempArr;

                if (loopNumber == 0) {
                    var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
                    $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
                } else if (loopNumber == 1) {
                    var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
                    $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
                } else if (loopNumber == 2) {
                    var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
                    $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
                } else if (loopNumber == 3) {
                    var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
                    $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
                } else if (loopNumber == 4) {
                    var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
                    $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
                } else if (loopNumber == 5) {
                    var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
                    $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
                } else if (loopNumber == 6) {
                    var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
                    $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
                }

                k = k + 24 * 60 * 60 * 1000;
                loopNumber++;
            }
        } else {

            // 组织数据
            for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

                var tempArr = [];

                if (k < nowDateTime) {

                    if (caac.util.isNotEmpty(historySchedulerArr)) {

                        for (var i = 0; i < historySchedulerArr.length; i++) {

                            if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].creator == selectedUser) {
                                tempArr.push(historySchedulerArr[i]);
                            }

                            if (historySchedulerArr[i].endDate < k) {
                                break;
                            }
                        }
                    }

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].creator == selectedUser) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }
                } else {

                    if (caac.util.isNotEmpty(futureSchedulerArr)) {

                        for (var i = 0; i < futureSchedulerArr.length; i++) {

                            if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].creator == selectedUser) {
                                tempArr.push(futureSchedulerArr[i]);
                            }

                            if (futureSchedulerArr[i].startDate > k) {
                                break;
                            }
                        }
                    }
                }

                // 组织数据
                var tempData = {};
                tempData.dateStr = new Date(k).getDate();
                tempData.list = tempArr;

                if (loopNumber == 0) {
                    var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
                    $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
                } else if (loopNumber == 1) {
                    var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
                    $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
                } else if (loopNumber == 2) {
                    var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
                    $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
                } else if (loopNumber == 3) {
                    var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
                    $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
                } else if (loopNumber == 4) {
                    var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
                    $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
                } else if (loopNumber == 5) {
                    var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
                    $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
                } else if (loopNumber == 6) {
                    var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
                    $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
                }

                k = k + 24 * 60 * 60 * 1000;
                loopNumber++;
            }
        }
    })
};

/**
 * 点击具体人员
 */
workdynamicsView.onClickUser = function (userNo) {

    // 隐藏List
    $(".fj-calendar-container .fj-schedule-view .fj-user-list").addClass("fj-hidden");

    // 删除之前有的选中
    $(".fj-calendar-container .fj-user-item").removeClass("fj-selected");
    // 添加新的选中
    $(".fj-calendar-container #" + userNo).addClass("fj-selected");

    // 设置选中的人员
    workdynamicsView.viewModel.set("selectedUser", userNo);

    // 获取选中的单位
    var selectedDp = workdynamicsView.viewModel.get("selectedDp");

    var oldWeekStartDate = workdynamicsView.viewModel.get("weekStartDate");

    var weekStartDate = new Date(oldWeekStartDate.getFullYear(), oldWeekStartDate.getMonth(), oldWeekStartDate.getDate());

    // 本星期结束时间
    var weekEndDate = new Date(weekStartDate.getFullYear(), weekStartDate.getMonth(), weekStartDate.getDate() + 6);

    // 设置星期展示
    //workdynamicsView.viewModel.set("weekDateShow", weekStartDate.getFullYear() + "年" + (weekStartDate.getMonth() + 1) + "月" + weekStartDate.getDate() + "日" + " - " + weekEndDate.getFullYear() + "年" + (weekEndDate.getMonth() + 1) + "月" + weekEndDate.getDate());

    var nowDateTime = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate()).getTime();

    var historySchedulerArr = workdynamicsView.viewModel.get("historyScheduler");
    var futureSchedulerArr = workdynamicsView.viewModel.get("futureScheduler");

    var loopNumber = 0;

    if (userNo == "allUserNo") {

        // 组织数据
        for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

            var tempArr = [];

            if (k < nowDateTime) {

                if (caac.util.isNotEmpty(historySchedulerArr)) {

                    for (var i = 0; i < historySchedulerArr.length; i++) {

                        if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].deptNo == selectedDp) {
                            tempArr.push(historySchedulerArr[i]);
                        }

                        if (historySchedulerArr[i].endDate < k) {
                            break;
                        }
                    }
                }

                if (caac.util.isNotEmpty(futureSchedulerArr)) {

                    for (var i = 0; i < futureSchedulerArr.length; i++) {

                        if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == selectedDp) {
                            tempArr.push(futureSchedulerArr[i]);
                        }

                        if (futureSchedulerArr[i].startDate > k) {
                            break;
                        }
                    }
                }
            } else {

                if (caac.util.isNotEmpty(futureSchedulerArr)) {

                    for (var i = 0; i < futureSchedulerArr.length; i++) {

                        if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == selectedDp) {
                            tempArr.push(futureSchedulerArr[i]);
                        }

                        if (futureSchedulerArr[i].startDate > k) {
                            break;
                        }
                    }
                }
            }

            // 组织数据
            var tempData = {};
            tempData.dateStr = new Date(k).getDate();
            tempData.list = tempArr;

            if (loopNumber == 0) {
                var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
                $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
            } else if (loopNumber == 1) {
                var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
                $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
            } else if (loopNumber == 2) {
                var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
                $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
            } else if (loopNumber == 3) {
                var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
                $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
            } else if (loopNumber == 4) {
                var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
                $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
            } else if (loopNumber == 5) {
                var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
                $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
            } else if (loopNumber == 6) {
                var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
                $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
            }

            k = k + 24 * 60 * 60 * 1000;
            loopNumber++;
        }
    } else {

        // 组织数据
        for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

            var tempArr = [];

            if (k < nowDateTime) {

                if (caac.util.isNotEmpty(historySchedulerArr)) {

                    for (var i = 0; i < historySchedulerArr.length; i++) {

                        if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].creator == userNo) {
                            tempArr.push(historySchedulerArr[i]);
                        }

                        if (historySchedulerArr[i].endDate < k) {
                            break;
                        }
                    }
                }

                if (caac.util.isNotEmpty(futureSchedulerArr)) {

                    for (var i = 0; i < futureSchedulerArr.length; i++) {

                        if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].creator == userNo) {
                            tempArr.push(futureSchedulerArr[i]);
                        }

                        if (futureSchedulerArr[i].startDate > k) {
                            break;
                        }
                    }
                }
            } else {

                if (caac.util.isNotEmpty(futureSchedulerArr)) {

                    for (var i = 0; i < futureSchedulerArr.length; i++) {

                        if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].creator == userNo) {
                            tempArr.push(futureSchedulerArr[i]);
                        }

                        if (futureSchedulerArr[i].startDate > k) {
                            break;
                        }
                    }
                }
            }

            // 组织数据
            var tempData = {};
            tempData.dateStr = new Date(k).getDate();
            tempData.list = tempArr;

            if (loopNumber == 0) {
                var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
                $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
            } else if (loopNumber == 1) {
                var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
                $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
            } else if (loopNumber == 2) {
                var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
                $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
            } else if (loopNumber == 3) {
                var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
                $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
            } else if (loopNumber == 4) {
                var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
                $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
            } else if (loopNumber == 5) {
                var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
                $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
            } else if (loopNumber == 6) {
                var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
                $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
            }

            k = k + 24 * 60 * 60 * 1000;
            loopNumber++;
        }
    }
};

/**
 * 点击具体部门
 */
workdynamicsView.onClickDepartment = function (departmentNo) {

    // 隐藏List
    $(".fj-calendar-container .fj-schedule-view .fj-department-list").addClass("fj-hidden");

    // 删除之前有的选中
    $(".fj-calendar-container .fj-department-item").removeClass("fj-selected");
    // 添加新的选中
    $(".fj-calendar-container #" + departmentNo).addClass("fj-selected");

    // 设置当前选中的部门
    workdynamicsView.viewModel.set("selectedDp", departmentNo);

    // 重置人员
    var userList = workdynamicsView.viewModel.get("userArr");

    var showUserArr = [];

    showUserArr.push(userList[0]);

    for (var i = 1, len = userList.length; i < len; i++) {

        if (userList[i].departmentNo == departmentNo) {

            showUserArr.push(userList[i]);
        }
    }

    // 设置显示的人员
    var userTemplate = kendo.template($(".fj-calendar-container #tmplt_user_content").html());
    $(".fj-calendar-container .fj-user-list").html(userTemplate(showUserArr));

    $(".fj-calendar-container #allUserNo").addClass("fj-selected");

    var oldWeekStartDate = workdynamicsView.viewModel.get("weekStartDate");

    var weekStartDate = new Date(oldWeekStartDate.getFullYear(), oldWeekStartDate.getMonth(), oldWeekStartDate.getDate());

    // 本星期结束时间
    var weekEndDate = new Date(weekStartDate.getFullYear(), weekStartDate.getMonth(), weekStartDate.getDate() + 6);

    // 设置星期展示
    //workdynamicsView.viewModel.set("weekDateShow", weekStartDate.getFullYear() + "年" + (weekStartDate.getMonth() + 1) + "月" + weekStartDate.getDate() + "日" + " - " + weekEndDate.getFullYear() + "年" + (weekEndDate.getMonth() + 1) + "月" + weekEndDate.getDate());

    var nowDateTime = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate()).getTime();

    var historySchedulerArr = workdynamicsView.viewModel.get("historyScheduler");
    var futureSchedulerArr = workdynamicsView.viewModel.get("futureScheduler");

    var loopNumber = 0;

    // 组织数据
    for (var k = weekStartDate.getTime(); k <= weekEndDate.getTime();) {

        var tempArr = [];

        if (k < nowDateTime) {

            if (caac.util.isNotEmpty(historySchedulerArr)) {

                for (var i = 0; i < historySchedulerArr.length; i++) {

                    if (historySchedulerArr[i].startDate <= k && historySchedulerArr[i].endDate >= k && historySchedulerArr[i].deptNo == departmentNo) {
                        tempArr.push(historySchedulerArr[i]);
                    }

                    if (historySchedulerArr[i].endDate < k) {
                        break;
                    }
                }
            }

            if (caac.util.isNotEmpty(futureSchedulerArr)) {

                for (var i = 0; i < futureSchedulerArr.length; i++) {

                    if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == departmentNo) {
                        tempArr.push(futureSchedulerArr[i]);
                    }

                    if (futureSchedulerArr[i].startDate > k) {
                        break;
                    }
                }
            }
        } else {

            if (caac.util.isNotEmpty(futureSchedulerArr)) {

                for (var i = 0; i < futureSchedulerArr.length; i++) {

                    if (futureSchedulerArr[i].startDate <= k && futureSchedulerArr[i].endDate >= k && futureSchedulerArr[i].deptNo == departmentNo) {
                        tempArr.push(futureSchedulerArr[i]);
                    }

                    if (futureSchedulerArr[i].startDate > k) {
                        break;
                    }
                }
            }
        }

        // 组织数据
        var tempData = {};
        tempData.dateStr = new Date(k).getDate();
        tempData.list = tempArr;

        if (loopNumber == 0) {
            var sunTemplate = kendo.template($(".fj-calendar-container #tmplt_sun_content").html());
            $(".fj-calendar-container #dv_sun").html(sunTemplate(tempData));
        } else if (loopNumber == 1) {
            var monTemplate = kendo.template($(".fj-calendar-container #tmplt_mon_content").html());
            $(".fj-calendar-container #dv_mon").html(monTemplate(tempData));
        } else if (loopNumber == 2) {
            var tueTemplate = kendo.template($(".fj-calendar-container #tmplt_tue_content").html());
            $(".fj-calendar-container #dv_tue").html(tueTemplate(tempData));
        } else if (loopNumber == 3) {
            var wedTemplate = kendo.template($(".fj-calendar-container #tmplt_wed_content").html());
            $(".fj-calendar-container #dv_wed").html(wedTemplate(tempData));
        } else if (loopNumber == 4) {
            var thuTemplate = kendo.template($(".fj-calendar-container #tmplt_thu_content").html());
            $(".fj-calendar-container #dv_thu").html(thuTemplate(tempData));
        } else if (loopNumber == 5) {
            var friTemplate = kendo.template($(".fj-calendar-container #tmplt_fri_content").html());
            $(".fj-calendar-container #dv_fri").html(friTemplate(tempData));
        } else if (loopNumber == 6) {
            var satTemplate = kendo.template($(".fj-calendar-container #tmplt_sat_content").html());
            $(".fj-calendar-container #dv_sat").html(satTemplate(tempData));
        }

        k = k + 24 * 60 * 60 * 1000;
        loopNumber++;
    }
};

/**
 * 点击事件跳转到修改页面
 */
workdynamicsView.onClickEvent = function (schedulerNo) {

    workdynamicsView.workdynamics = {};
    workdynamicsView.workdynamics.returnType = 2;
    workdynamicsView.workdynamics.schedulerNo = schedulerNo;
    caac.guiframe.switchView("workdynamicsform", workdynamicsView.workdynamics, null, ".fj-content-container");
};
