var workdynamicsformView = caac.guiframe.getView("workdynamicsform");

/**
 * 打开视图方法
 */
function onViewOpened(name, args, callback, viewContainer) {

    workdynamicsformView.initParams = args;

    // 初始化控件
    workdynamicsformView.initWidgets();
    // 初始化数据
    workdynamicsformView.initData();
    // 初始化事件
    workdynamicsformView.initEvents();
}

/**
 * 初始化控件
 */
workdynamicsformView.initWidgets = function () {

    //  如果是工作动态进来，显示删除按钮
    if (caac.util.isNotBlank(workdynamicsformView.initParams.schedulerNo)) {

        document.getElementById("btn_delete").className = "k-button k-primary";
    }

    workdynamicsformView.viewModel = kendo.observable({
        schedulerNo: null,
        title: null,
        startDate: null,
        endDate: null
    });

    kendo.bind($(".fj-workdynamicsform-container"), workdynamicsformView.viewModel);

    $(".fj-workdynamicsform-container #dt_start_date").kendoDatePicker({
        format: "yyyy-MM-dd"
    });

    $(".fj-workdynamicsform-container #dt_end_date").kendoDatePicker({
        format: "yyyy-MM-dd"
    });
};

/**
 * 初始化数据
 */
workdynamicsformView.initData = function () {

    // 如果不是新建
    if (caac.util.isNotBlank(workdynamicsformView.initParams.schedulerNo)) {

        var args = {
            schedulerNo: workdynamicsformView.initParams.schedulerNo
        };

        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerform/initdata.act", {args: JSON.stringify(args)}, function (result) {
            caac.util.doReturnValue({
                returnValue: result,
                success: function (data) {

                    workdynamicsformView.viewModel.set("schedulerNo", data.schedulerNo);
                    workdynamicsformView.viewModel.set("title", data.title);
                    workdynamicsformView.viewModel.set("startDate", new Date(data.startDate));
                    workdynamicsformView.viewModel.set("endDate", new Date(data.endDate));
                },
                error: function (data) {

                    caac.guiframe.showMessage(result.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    }
};

/**
 * 初始化化事件
 */
workdynamicsformView.initEvents = function () {

    // 绑定确认按钮
    $(".fj-workdynamicsform-container #btn_ok").bind("click", function () {

        var item = {
            schedulerNo: workdynamicsformView.viewModel.get("schedulerNo"),
            startDate: kendo.toString(workdynamicsformView.viewModel.get("startDate"), "yyyy-MM-dd"),
            endDate: kendo.toString(workdynamicsformView.viewModel.get("endDate"), "yyyy-MM-dd"),
            title: $(".fj-workdynamicsform-container #text_title").val()
        };

        //校验
        caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerform/check.act", {args: JSON.stringify(item)}, function (data) {
            caac.util.doReturnValue({
                returnValue: data,
                success: function (result) {

                    workdynamicsformView.save(item);
                },
                error: function (result) {
                    caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
                }
            });
        });
    });

    // 绑定删除按钮
    $(".fj-workdynamicsform-container #btn_delete").bind("click", function () {

        var item = {
            schedulerNo: workdynamicsformView.viewModel.get("schedulerNo")
        };

        var message = "是否确认删除该工作动态？";
        var title = "提示";
        var buttonLabels = "是,否";

        navigator.notification.confirm(message, function (buttonIndex) {

            if (buttonIndex == 1) {

                caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerform/delete.act", item, function (data) {
                    caac.util.doReturnValue({
                        returnValue: data,
                        success: function (result) {

                            if (workdynamicsformView.initParams.returnType == 1) {

                                // 返回个人信息页面
                                caac.guiframe.switchView("personal", null, null, ".fj-content-container");
                            } else if (workdynamicsformView.initParams.returnType == 2) {

                                // 返回工作动态页面
                                caac.guiframe.switchView("workdynamics", null, null, ".fj-content-container");
                            }

                            caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
                        },
                        error: function (result) {
                            caac.guiframe.showMessage("请求服务器失败", caac.constants.messageTypes.WARNING);
                        }
                    });
                });
            }
        }, title, buttonLabels);
    });

    // 绑定返回按钮
    $(".fj-workdynamicsform-container #dv_back_symbol").bind("click", function () {

        if (workdynamicsformView.initParams.returnType == 1) {

            // 返回个人信息页面
            caac.guiframe.switchView("personal", null, null, ".fj-content-container");
        } else if (workdynamicsformView.initParams.returnType == 2) {

            // 返回工作动态页面
            caac.guiframe.switchView("workdynamics", null, null, ".fj-content-container");

        }
    });
};

/**
 * 保存数据
 */
workdynamicsformView.save = function (args) {
    caac.util.postServerEvent(caac.constants.httpHead.URLHEAD + "schedulerform/save.act", {args: JSON.stringify(args)}, function (data) {
        caac.util.doReturnValue({
            returnValue: data,
            success: function (result) {

                if (workdynamicsformView.initParams.returnType == 1) {

                    // 返回个人信息页面
                    caac.guiframe.switchView("personal", null, null, ".fj-content-container");
                    caac.guiframe.showMessage("工作动态创建成功", caac.constants.messageTypes.SUCCESS);
                } else if (workdynamicsformView.initParams.returnType == 2) {

                    // 返回工作动态页面
                    caac.guiframe.switchView("workdynamics", null, null, ".fj-content-container");
                    caac.guiframe.showMessage("工作动态修改成功", caac.constants.messageTypes.SUCCESS);
                }

            },
            error: function (result) {
                caac.guiframe.showMessage(data.message, caac.constants.messageTypes.WARNING);
            }
        });
    });
};