/*jshint esversion: 6 */

// 声明常量对象
caac.constants = {

    // 声明检索结果类型
    searchResultType: (function () {

        // 声明检索结果类型
        const searchResultType = {
            ALL_RESULT: "all_result",
            RESULT_PER_PAGE: "result_per_page",
            SELECTED_RESULT: "selected_result",
            PAGE_NOS: "page_nos"
        };

        // 返回检索结果类型
        return searchResultType;
    })(),

    // 声明消息类型
    messageTypes: (function () {

        // 声明消息类型
        const messageTypes = {
            INFORMATION: "info",
            WARNING: "warning",
            ERROR: "error",
            SUCCESS: "success"
        };

        // 返回消息类型
        return messageTypes;
    })(),

    // 声明默认日期时间格式
    defaultDateTimeFormat: (function () {

        // 声明默认日期时间格式
        const defaultDateTimeFormat = "yyyy/MM/dd hh:mm";

        // 返回默认日期时间格式
        return defaultDateTimeFormat;
    })(),

    // 声明日期默认格式
    defaultDateFormat: (function () {

        // 声明日期默认格式
        const defaultDateFormat = "yyyy/MM/dd";

        // 返回日期默认格式
        return defaultDateFormat;
    })(),

    // 声明时间默认格式
    defaultTimeFormat: (function () {

        // 声明时间默认格式
        const defaultTimeFormat = "hh:ii";

        // 返回时间默认格式
        return defaultTimeFormat;
    })(),

    // 声明区域信息常量
    locales: (function () {

        // 声明区域信息常量
        const locales = {
            DEFAULT: "default",
            CHINA: "zh-CN",
            AMERICA: "en-US"
        };

        // 返回区域信息常量
        return locales;
    })(),

    // 声明执行结果
    results: (function () {

        // 声明执行结果
        const results = {
            EXECUTION_RESULT_SUCCESS: "success",
            EXECUTION_RESULT_ERROR: "error"
        };

        // 返回执行结果常量
        return results;
    })(),

    // 声明按钮类型
    buttons: (function () {

        // 声明按钮类型
        const buttons = {
            OK: 1,
            CANCEL: 2,
            YES: 4,
            NO: 8
        };

        // 返回按钮类型
        return buttons;
    })(),

    // 声明消息框类型
    messageBoxType: (function () {

        // 声明消息框类型
        const messageBoxType = {
            INFORMATION: 1,
            WARNING: 2,
            ERROR: 3,
            QUESTION: 4
        };

        // 返回消息框类型
        return messageBoxType;
    })(),

    // 声明页面类型
    frameType: (function () {

        // 声明页面类型
        const frameType = {
            VIEW: 1,
            DIALOG: 2,
            COMMON: 3
        };

        // 返回页面类型
        return frameType;
    })(),

    // 声明初始化方法名称
    initFunctionName: (function () {

        // 声明初始化方法名称
        const initFunctionName = "onInit";

        // 返回初始化方法名称
        return initFunctionName;
    })(),

    // 声明画面渲染方法名称
    renderFunctionName: (function () {

        // 声明画面渲染方法名称
        const renderFunctionName = "onRender";

        // 返回画面渲染方法名称
        return renderFunctionName;
    })(),

    // 声明初始化参数名称
    initArgsName: (function () {

        // 声明初始化参数名称
        const initArgsName = "initArgs";

        // 返回初始化参数名称
        return initArgsName;
    })(),

    // 声明回调方法名称
    callbackFunctionName: (function () {

        // 声明回调方法名称
        const callbackFunctionName = "callback";

        // 返回初始化方法名称
        return callbackFunctionName;
    })(),

    // 声明容器样式
    containerStyle: (function () {

        // 声明容器样式
        const containerStyle = {
            DIALOG_CONTAINER: ".fj-dialog-container",
            COMMON_CONTAINER: ".fj-common-container",
            COMMON_EXT_CONTAINER: ".fj-common-ext-container",
            BIG_COMMON_CONTAINER: ".fj-big-common-container",
        };

        // 返回容器样式
        return containerStyle;
    })(),

    // 声明目录路径
    folderPath: (function () {

        // 声明目录路径
        const folderPath = {
            UPLOAD: "storage",
            PORTRAIT: "caac/styles/caac/images/portrait"
        };

        // 返回目录路径
        return folderPath;
    })(),

    // 声明用户状态
    userStatus: (function () {

        // 声明用户状态
        const userStatus = {
            UNLOCK: 0,
            LOCKED: 1
        };

        // 返回用户状态
        return userStatus;
    })(),

    // 声明性别
    gender: (function () {

        // 声明性别
        const gender = {
            MALE: 1,
            FEMALE: 2
        };

        // 返回性别
        return gender;
    })(),

    //dialog 对话框的size
    dialogSize: (function () {
        const dialogSize = {
            WIDTH: 1024,
            HEIGHT: 576,
            SCROLL: 520
        };
        return dialogSize;
    })(),
    //common 对话框的size
    commonSize: (function () {
        const commonSize = {
            WIDTH: 800,
            HEIGHT: 450,
            SCROLL: 394
        };
        return commonSize;
    })(),
    //policyType 组策略类型
    policyType: (function () {
        const policyType = {
            FUNCTION: 1,
            SYSTEM: 2
        };
        return policyType;
    })(),

    // 声明成员类型
    memberType: (function () {

        // 声明成员类型
        const memberType = {
            ALL: 0,
            USER: 1,
            GROUP: 2
        };

        // 返回成员类型
        return memberType;
    })(),

    // 声明选择类型
    selectType: (function () {

        // 声明选择类型
        const selectType = {
            ALL: 1,
            USERS: 2,
            GROUPS: 3
        };

        // 返回选择类型
        return selectType;
    })(),

    // 声明选择单位类型
    selectUnitType: (function () {

        // 声明选择类型
        const selectUnitType = {
            ALL: 1,
            EXEC_UNIT: 2,
            BIZ_UNIT: 3,
            EXEC_DEPT: 4,
            BIZ_DEPT: 5,
            BIZ_LOCATION: 6
        };

        // 返回选择类型
        return selectUnitType;
    })(),

    // 声明选择人员类型
    selectUserType: (function () {

        // 声明选择类型
        const selectUserType = {
            ALL: 1,
            GROUP: 2,
            USER: 3,
            ISUSER: 4
        };
        // 返回选择类型
        return selectUserType;
    })(),


    //声明返回人员类型
    numberUserType: (function () {

        // 声明选择类型
        const numberUserType = {
            GROUP: 2,
            USER: 1
        };
        // 返回选择类型
        return numberUserType;
    })(),

    // 声明选择单位类型
    selectUnitCata: (function () {

        // 声明选择单位级别：1 民航局，2 地方局，3 安监局
        const selectUnitCata = {
            GENERAL: 1,
            ADMIN: 2,
            SAFETY: 3
        };

        // 返回选择类型
        return selectUnitCata;
    })(),

    // 声明是否显示部门
    showDepartment: (function () {

        // 声明选择类型
        const showDepartment = {
            TRUE: 1,
            FALSE: 0
        };

        // 返回选择类型
        return showDepartment;
    })(),

    // 声明浏览器类型
    navigatorType: (function () {

        // 声明浏览器类型
        const navigatorType = {
            IE: 1,
            EDGE: 2,
            FIREFOX: 3,
            CHROME: 4,
            OTHER: 5
        };

        // 返回浏览器类型
        return navigatorType;
    })(),

    // 声明单位公私属性常量
    isPublic: (function () {

        // 声明单位公私属性常量
        const isPublic = {
            IS_PUB: 1,
            IS_PRIV: 2
        };

        // 返回浏览器类型
        return isPublic;
    })(),

    // 声明显示的数据状态
    isShowDeleted: (function () {

        // 声明单位公私属性常量
        const isShowDeleted = {
            UNDELETED: 0,
            DELETED: 1,
            ALL: 2
        };

        // 返回浏览器类型
        return isShowDeleted;
    })(),
    // 声明显示的数据状态
    isShowStatus: (function () {

        // 声明单位公私属性常量
        const isShowStatus = {
            INVALID: 0,
            VALID: 1,
            ALL: 2
        };

        // 返回浏览器类型
        return isShowStatus;
    })(),

    // 声明删除状态
    isDeleted: (function () {

        // 声明单位公私属性常量
        const isDeleted = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isDeleted;
    })(),

    // 声明状态
    status: (function () {

        // 声明单位公私属性常量
        const status = {
            INVALID: 0,
            VALID: 1
        };
        // 返回浏览器类型
        return status;
    })(),

    // 声明赤黑类型
    rbType: (function () {

        // 声明单位公私属性常量
        const rbType = {
            RED: 0,
            BLACK: 1
        };
        // 返回浏览器类型
        return rbType;
    })(),
    // 声明是否锁定
    isLocked: (function () {

        // 声明锁定状态属性常量
        const isLocked = {
            NO: 0,
            YES: 1,
            SELF: 2
        };
        // 返回锁定状态
        return isLocked;
    })(),
    // 声明文档类型
    documentType: (function () {

        // 声明单位公私属性常量
        const documentType = {
            ARTICLE: 1,
            FORUM: 2,
            INNER_MAIL: 3,
            SYS_MSG: 4,
            WORKFLOW: 5
        };
        // 返回浏览器类型
        return documentType;
    })(),

    // 声明文章预览类型
    previewType: (function () {

        // 声明单位公私属性常量
        const previewType = {
            LINK: 1,
            ONLINE: 2
        };
        // 返回浏览器类型
        return previewType;
    })(),
    // 声明事件类型  是report 还是draft 还是续报
    ReportType: (function () {
        // 声明单位公私属性常量
        const ReportType = {
            REPORT: 0,
            DRAFT: 1,
            CONTINUE: 2
        };
        // 返回浏览器类型
        return ReportType;
    })(),
    // 是否待发送
    isOutgoing: (function () {
        // 声明单位公私属性常量
        const isOutgoing = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isOutgoing;
    })(),
    // 是否 退回
    isReturn: (function () {
        // 声明单位公私属性常量
        const isReturn = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isReturn;
    })(),
    // 声明事件发送的类型  主报还是抄报  默认主报 0
    ReportSendType: (function () {
        // 声明主报的类型
        const ReportSendType = {
            MAIN: 0,
            COPY: 1
        };
        // 返回浏览器类型
        return ReportSendType;
    })(),
    // 声明操作类型
    operationType: (function () {
        // 声明单位公私属性常量
        const operationType = {
            SEND: 'EVENT_OPERATION_SEND',
            OUTGOING: 'EVENT_OPERATION_OUTGOING',
            RETURN: 'EVENT_OPERATION_RETURN',
            PUBLISH: 'EVENT_OPERATION_PUBLISH',
            RESUBMIT: 'EVENT_OPERATION_RESUBMIT'
        };
        // 返回浏览器类型
        return operationType;
    })(),
    messageType: (function () {
        // 声明工作台中的消息类型常量
        const messageType = {
            ARTICLE: "msg_news",
            FORUM: "msg_forum",
            INNERMAIL: "msg_innermail",
            UNSAFE_EVENT_INBOX: "msg_unsafe_inbox",
            UNSAFE_EVENT_OUTBOX: "msg_unsafe_outbox",
            UNSAFE_EVENT_UNTREATED: "msg_untreated_event",
            UNSAFE_EVENT_OUTGOING: "msg_unsafe_outgoing",
            UNSAFE_EVENT_TODELAY: "msg_unsafe_todelay_event",
            UNSAFE_EVENT_INSTRUCTIONS: "msg_unsafe_eventdiscuss",
            UNSAFE_EVENT_REMINDER: "msg_unsafe_event_reminder"
        };
        // 返回页面类型
        return messageType;
    })(),
    //单位类型：任意、主送、抄送
    mainOrCopy: (function () {
        // 时间的毫秒数
        const mainOrCopy = {
            ALL: "ALL",
            MAIN: "MAIN",
            COPY: "COPY"
        };
        return mainOrCopy;
    })(),
    isIgnored: (function () {
        // 声明是否忽略常量
        const isIgnored = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isIgnored;
    })(),
    eventDate: (function () {
        // 时间的毫秒数
        const eventDate = {
            DATE12: 43200000,
            DATE24: 86400000,
            DATE48: 172800000
        };
        // 返回浏览器类型
        return eventDate;
    })(),

    telephoneUnitType: (function () {
        // 声明联系电话的单位类型
        const telephoneUnitType = {
            EXE_UNIT: 1,
            BIZ_UNIT: 0
        };
        return telephoneUnitType;
    })(),
    isHandled: (function () {
        // 声明是否忽略常量
        const isHandled = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isHandled;
    })(),
    yes_no: (function () {
        // 声明是否忽略常量
        const isHandled = {
            NO: 0,
            YES: 1
        };
        // 返回浏览器类型
        return isHandled;
    })(),

    // 声明最大上传文件大小
    maxUploadFileSize: (function () {

        // 声明最大上传文件大小
        const maxUploadFileSize = 52428800;

        // 返回最大上传文件大小
        return maxUploadFileSize;
    })(),
    advancedSearchType: (function () {
        // 声明单位公私属性常量
        const advancedSearchType = {
            UNSAFE_INBOX: "UNSAFE_INBOX",
            UNSAFE_OUTBOX: "UNSAFE_OUTBOX",
            UNSAFE_EVENT_LIBRARY: "UNSAFE_EVENT_LIBRARY",
            UNSAFE_PUBLISHED_DATA: "UNSAFE_PUBLISHED_DATA"
        };
        // 返回浏览器类型
        return advancedSearchType;
    })(),
    // 是否有数据
    isHaveData: (function () {

        // 声明是否有数据状态常量
        const isHaveData = {
            NO: 0,
            YES: 1
        };
        // 返回是否有数据状态
        return isHaveData;
    })(),
    httpHead: (function () {
        const httpHead = {
            //URLHEAD: "http://192.168.137.1:8080/mobility/"
            //URLHEAD: "http://192.168.95.1:8080/mobility/"
            URLHEAD: "https://safety.caac.gov.cn:9080/"
        };
        return httpHead;
    })()
};
